//
// $XConsortium$
//

//
// Copyright (c) 1993-94 Silicon Graphics, Inc.
// Copyright (c) 1993-94 Fujitsu, Ltd.
//
// Permission to use, copy, modify, distribute, and sell this software and 
// its documentation for any purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the names of
// Silicon Graphics and Fujitsu may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Silicon Graphics and Fujitsu.
//
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
//
// IN NO EVENT SHALL SILICON GRAPHICS OR FUJITSU BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
//

#ifndef ox_base_h
#define ox_base_h

class OxEnv;
class OxExchange;
class OxMarshalBuffer;

#include "ix.h"
#include "corba.h"

#ifndef nil
#define nil 0
#endif

typedef CORBA::Boolean OxBoolean;

//
// The constants true and false are #define constants to avoid clash
// with (future) C++ compilers that support the type bool.
//

#if !defined(__GNUC__)
#ifndef false
#define false 0
#endif

#ifndef true
#define true 1
#endif
#endif

#ifndef TRUE
#define TRUE true
#endif

#ifndef FALSE
#define FALSE false
#endif

typedef CORBA::Boolean Boolean;
typedef CORBA::Char Char;
typedef CORBA::UChar UChar;
typedef CORBA::Octet Octet;
typedef CORBA::Short Short;
typedef CORBA::UShort UShort;
typedef CORBA::Long Long;
typedef CORBA::ULong ULong;

#if defined(__sgi) || defined(__GNUC__)
// Add to #if platforms that support long long
typedef CORBA::LongLong LongLong;
typedef CORBA::ULongLong ULongLong;
#else
typedef CORBA::Long LongLong;
typedef CORBA::ULong ULongLong;
#endif

typedef CORBA::Float Float;
typedef CORBA::Double Double;

#ifndef ox_is_nil
#define ox_is_nil

inline export Boolean is_nil(CORBA::Object_ptr p) { return CORBA::is_nil(p); }
inline export Boolean is_not_nil(CORBA::Object_ptr p) { return !CORBA::is_nil(p); }

#endif

#ifndef ox_is_eq

//
// Beware: Testing if two object references denote the same object
// implementation can be expensive.
//

extern import Boolean _ox_is_eq(CORBA::Object_ptr p1, CORBA::Object_ptr p2);

inline Boolean is_eq(CORBA::Object_ptr p1, CORBA::Object_ptr p2) {
    return p1 == p2 || _ox_is_eq(p1, p2);
}

#endif

//
// StubCreator is simply a pointer to a constructor for a proxy.
// C++ doesn't allow pointers to constructors because they may have
// additional hidden parameters.
//
// This definition is necessary here because both Exchange and
// MarshalBuffer use it, and we wanted those two to be independent.
//
typedef void* (*OxStubCreator)(OxExchange*);

#endif
