//
// $XConsortium$
//

//
// Copyright (c) 1993-94 Silicon Graphics, Inc.
// Copyright (c) 1993-94 Fujitsu, Ltd.
//
// Permission to use, copy, modify, distribute, and sell this software and 
// its documentation for any purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the names of
// Silicon Graphics and Fujitsu may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Silicon Graphics and Fujitsu.
//
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
//
// IN NO EVENT SHALL SILICON GRAPHICS OR FUJITSU BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
//

//
// Environment stuff
//

#include <Ox/env.h>

// class Env

OxEnv::OxEnv() {
    raised_ = nil;
    info_ = nil;
}

OxEnv::~OxEnv() {
    delete raised_;
}

void OxEnv::exception(CORBA::Exception* e) {
    delete raised_;
    raised_ = e;
}

CORBA::Exception* OxEnv::exception() const {
    return raised_;
}

void OxEnv::clear_exception() {
    delete raised_;
    raised_ = nil;
}

OxMethodInfo& OxEnv::method_info() const {
    return *info_;
}

OxEnv::ExceptionHandler OxEnv::exception_handler(ExceptionHandler h) {
    ExceptionHandler prev = handler_;
    handler_ = h;
    return prev;
}

OxEnv::ExceptionHandler OxEnv::handler_;
