//
// $XConsortium$
//

//
// Copyright (c) 1993-94 Silicon Graphics, Inc.
// Copyright (c) 1993-94 Fujitsu, Ltd.
//
// Permission to use, copy, modify, distribute, and sell this software and 
// its documentation for any purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the names of
// Silicon Graphics and Fujitsu may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Silicon Graphics and Fujitsu.
//
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
//
// IN NO EVENT SHALL SILICON GRAPHICS OR FUJITSU BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
//

#ifndef ox_rpc_exch_h
#define ox_rpc_exch_h

#if OX_RPC_EXCHANGE

#include "exchange.h"

//
// Simple exchange for ONC RPC.  Not particularly well-tuned
// or customizable.
//

class OxRpcExchange : public OxForeignExchange {
public:
    OxRpcExchange(char* host, ULong port, ULong impl, ULong obj);
    ~OxRpcExchange();

    void op(OxMarshalBuffer&, CORBA::Object_ptr, CORBA::TypeId, Long method);
    Long invoke(OxMarshalBuffer&, Boolean oneway);
    void marshal(OxMarshalBuffer&, CORBA::Object_ptr);

    void* narrow(
	CORBA::Object_ptr obj, CORBA::TypeId obj_tid, CORBA::TypeId narrow_tid,
	OxStubCreator f
    );
protected:
    char* hostname_;
    ULong port_;
    ULong impl_;
    ULong obj_;
};

#endif

#endif
