//
// $XConsortium$
//

//
// Copyright (c) 1993-94 Silicon Graphics, Inc.
// Copyright (c) 1993-94 Fujitsu, Ltd.
//
// Permission to use, copy, modify, distribute, and sell this software and 
// its documentation for any purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the names of
// Silicon Graphics and Fujitsu may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Silicon Graphics and Fujitsu.
//
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
//
// IN NO EVENT SHALL SILICON GRAPHICS OR FUJITSU BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
//

#ifndef ox_schema_h
#define ox_schema_h

#include "base.h"
#include "exchange.h"

#define _Ix_CreateProxy(Q) _Ix_concat(_,_Ix_concat(Q,Stub_create))
#define _Ix_ExternProxy(Q) \
extern import void* _Ix_CreateProxy(Q)(OxExchange*)

#define _Ix_ImplementProxy(Q,T,_Q) \
_Ix_Proxy(Q)::_Ix_Proxy(T)(OxExchange* e) { exch_ = e; } \
_Ix_Proxy(Q)::~_Ix_Proxy(T)() { } \
\
void* _Ix_CreateProxy(_Q)(OxExchange* e) { \
    return new _Ix_Proxy(Q)(e); \
} \
\
OxExchange* _Ix_Proxy(Q)::_exchange() { return exch_; }

#define _Ix_BeginUnionMemberGet(T,u,member) \
    u._u.member = new T; \
    if (_b.allocated(u._u.member)) {

#define _Ix_EndUnionMemberGet() \
    }

#define _Ix_BeginSequencePut(T,seq) \
    _b.put_seq_hdr(&seq); \
    for (ULong i = 0; i < seq._length; i++) { \

#define _Ix_EndSequencePut() \
    }

#define _Ix_BeginSequenceGet(T,seq) \
    _b.get_seq_hdr(&seq); \
    if (seq._maximum != 0) { \
	seq._buffer = new T[seq._maximum]; \
	if (_b.allocated(seq._buffer)) { \
	    for (ULong i = 0; i < seq._length; i++) {

#define _Ix_EndSequenceGet() \
	    } \
	} \
    }

#define _Ix_GetInterfaceSeq(T,Y,seq) \
    _b.get_seq_hdr(&seq); \
    if (seq._maximum != 0) { \
	_Ix_T_ptr(T)* buf = new _Ix_T_ptr(T)[seq._maximum]; \
	seq._buffer = (_Ix_T_field(T)*)buf; \
	if (_b.allocated(buf)) { \
	    for (ULong i = 0; i < seq._length; i++) { \
		buf[i] = (_Ix_T_ptr(T))_b.get_object(&_Ix_CreateProxy(Y)); \
	    } \
	} \
    }

//
// This is wrong.  Expect some day that ExchangeId will be a pointer
// to a variable-length id.
//
typedef ULong OxExchangeId;

class OxTypeImpl;

//
// Define the receive function header.
//

#define _Ix_ReceiveHdr(Q,receive,reply) \
export void _Ix__receive(Q)( \
    CORBA::Object_ptr _object, ULong _m, \
    OxMarshalBuffer& receive, OxMarshalBuffer& reply \
)

//
// Type for pointer to receive function.
//
typedef void (*OxTypeObj_ReceiveFunc)(
    CORBA::Object_ptr, ULong, OxMarshalBuffer& receive, OxMarshalBuffer& reply
);

//
// Type for pointer to function that unmarshals an exception.
//
typedef CORBA::Exception* (*OxTypeObj_UnmarshalException)(OxMarshalBuffer&);

//
// Cast is an internal operation for receive functions.  It assumes
// a non-nil object reference and a known type id.
//
#define _Ix_CastReceiver(R,Q) \
    extern ULong _Ix__tid(Q)[]; \
    R _this = (R) _object->_narrow_tid(_Ix__tid(Q))

//
// These functions are global instead of static member functions
// to work around a compiler multiple inheritance bug.  If they are
// static member functions on CORBA::Object, then the compiler sometimes
// may complain a call to one is ambiguous because of a non-virtual
// inheritance diamond.
//
// Narrow returns a void* for the desired type or nil if the object's type
// cannot be widened to the desired type.
//
// Duplicate must return a void* that corresponds to the desired type.
// Release simply calls _release on the object unless the reference is nil.
//
extern import void* _ox_duplicate(
    CORBA::Object_ptr, void*, CORBA::TypeId, OxStubCreator
);

#define _Ix_ImplementGetTid(Q,tid) \
CORBA::TypeId Q::_tid() { return tid; }

#define _Ix_ImplementNarrow(R,Q,cast,_Q,creator) \
R Q::_narrow(CORBA::Object_ptr obj) { \
    return obj == nil ? nil : _duplicate((R)obj->_narrow_tid(_Ix__tid(_Q))); \
}

#define _Ix_ImplementNarrowFails(R,Q) \
R Q::_narrow(CORBA::Object_ptr) { return 0; }

#define _Ix_ImplementDuplicate(R,Q,cast,tid,creator) \
R Q::_duplicate(R obj) { \
    return (R)_ox_duplicate(cast obj, obj, tid, creator); \
}

#define _Ix_CopyNormalSeq(Qualified_S,S,T) \
void Qualified_S::copy(const S& s) { \
    _maximum = s._maximum; \
    _length = s._length; \
    if (_maximum == 0) { \
	_buffer = 0; \
    } else { \
	_buffer = new T[_maximum]; \
	for (ULong i = 0; i < _length; i++) { \
	    _buffer[i] = s._buffer[i]; \
	} \
	_release = true; \
    } \
}

#define _Ix_CopyInterfaceSeq(Qualified_S,S,T) \
void Qualified_S::copy(const S& s) { \
    _maximum = s._maximum; \
    _length = s._length; \
    if (_maximum == 0) { \
	_buffer = 0; \
    } else { \
	_Ix_T_ptr(T)* buf = new _Ix_T_ptr(T)[_maximum]; \
	for (ULong i = 0; i < _length; i++) { \
	    buf[i] = T::_duplicate(s._buffer[i]); \
	} \
	for (i = _length; i < _maximum; i++) { \
	    buf[i] = 0; \
	} \
	_release = true; \
	_buffer = (_Ix_T_field(T)*)buf; \
    } \
}

#define _Ix_FreeInterfaceSeq(Qualified_S,S,T) \
void Qualified_S::free() { \
    if (_release) { \
	_Ix_T_ptr(T)* buf = (_Ix_T_ptr(T)*)_buffer; \
	for (ULong i = 0; i < _length; i++) { \
	    _Ix_release(buf[i]); \
	} \
	delete [] buf; \
    } \
}

//
// Declare the implementation functions for an interface's field type.
//

#define _Ix_ImplementField(Qualified_T,T,cast) \
_Ix_T_field(Qualified_T)::_Ix_T_field(T)(const _Ix_T_field(T)& f) { \
    ptr_ = T::_duplicate(f.ptr_); \
} \
\
_Ix_T_field(Qualified_T)& _Ix_T_field(Qualified_T)::operator =( \
    const _Ix_T_field(T)& f \
) { \
    if (f.ptr_ != ptr_) { \
	_Ix_release(cast ptr_); \
	ptr_ = T::_duplicate(f.ptr_); \
    } \
    return *this; \
} \
\
_Ix_T_field(Qualified_T)& _Ix_T_field(Qualified_T)::operator =( \
    _Ix_T_ptr(T) p \
) { \
    if (p != ptr_) { \
	_Ix_release(cast ptr_); \
	ptr_ = p; \
    } \
    return *this; \
}

//
// These macro generate constructor/destructor definitions.
// In general constructors and destructors for interface types
// are unnecessary.  However, if we don't define them then
// some compilers will generate them automatically and (gag)
// dump out code for them instead of inlining them to nops.
// If we know the correct linkage identifiers to use, then
// we can fake the compiler/linker out by defining empty C functions.
//

#if defined(sgi) && !defined(__GNUG__)

#define _Ix_concat4(i1,i2,i3,i4) i1##i2##i3##i4
#define _Ix_concat6(i1,i2,i3,i4,i5,i6) i1##i2##i3##i4##i5##i6
#define _Ix_concat8(i1,i2,i3,i4,i5,i6,i7,i8) i1##i2##i3##i4##i5##i6##i7##i8

#define _Ix_ctdt_0(T,N) \
extern "C" export T* _Ix_concat4(__ct__,N,T,Fv)(T* obj) { return obj; } \
extern "C" export void _Ix_concat4(__dt__,N,T,Fv)(T*, int) { }

#define _Ix_ctdt_1(B1,N1,T,N) \
extern "C" export B1::T* _Ix_concat6(__ct__Q2_,N1,B1,N,T,Fv)(B1::T* obj) { \
    return obj; \
} \
extern "C" export void _Ix_concat6(__dt__Q2_,N1,B1,N,T,Fv)(B1::T*, int) { }

#else

#define _Ix_ctdt_0(T,N)\
T::T() { } \
T::~T() { }

#define _Ix_ctdt_1(B1,N1,T,N)\
B1::T::T() { } \
B1::T::~T() { }

#endif

class export OxSchema {
protected:
    OxSchema();
    ~OxSchema();
public:
    static OxSchema* schema();

    struct export TypeDescriptor {
	const char* name;
	CORBA::Type::TCKind kind;
	OxTypeImpl* type;
    };

    //
    // Because we can't initialize structs with a base class,
    // we resort to games around the type system.  Here we
    // define a type that is type-correct for the purposes of initialization.
    // We must cast values to TypeDescriptor to get the kind, and then
    // cast again to get the actual descriptor struct.
    //
    typedef void* TypeDescriptorPtr;

    struct export OperationData {
	const char* name;
	TypeDescriptorPtr result;
	Long nparams;
    };

    struct export ParameterData {
	const char* name;
	Long mode;
	TypeDescriptorPtr type;
    };

    //
    // These descriptors must contain a type descriptor header
    // so that a type descriptor with the matching kind tag can
    // be safely downcast to one of the specific descriptors.
    //

    struct export ExceptDescriptor {
	TypeDescriptor hdr;
	Long count;
	TypeDescriptorPtr* members;
	OxTypeObj_UnmarshalException unmarshal;
    };

    struct export InterfaceDescriptor {
	TypeDescriptor hdr;
	CORBA::TypeId id;
	InterfaceDescriptor** parents;
	ExceptDescriptor** excepts;
	OperationData* methods;
	ParameterData* params;
    };

    struct export TypedefDescriptor {
	TypeDescriptor hdr;
	TypeDescriptorPtr descriptor;
    };

    struct export ArrayDescriptor {
	TypeDescriptor hdr;
	TypeDescriptorPtr element;
	Long nsubscripts;
	Long* subscripts;
    };

    struct export StructDescriptor {
	TypeDescriptor hdr;
	Long count;
	TypeDescriptorPtr* members;
    };

    struct export UnionDescriptor {
	TypeDescriptor hdr;
	TypeDescriptorPtr tagtype;
	Long count;
	Long* cases;
	TypeDescriptorPtr* members;
    };

    struct export SequenceDescriptor {
	TypeDescriptor hdr;
	TypeDescriptorPtr element;
    };

    struct export EnumDescriptor {
	TypeDescriptor hdr;
	Long count;
    };

    struct export Receiver {
	CORBA::TypeId id;
	OxTypeObj_ReceiveFunc func;
    };

    void load_schema(InterfaceDescriptor**, Long length);
    void load_servers(Receiver*, Long length);

    CORBA::Type_ptr map(CORBA::TypeId);
    InterfaceDescriptor* descriptor(CORBA::TypeId);
    OxTypeObj_ReceiveFunc receiver(CORBA::TypeId);

    InterfaceDescriptor* get_descriptor(ULong start, OxMarshalBuffer&);
    CORBA::TypeId get_type_id(
	OxMarshalBuffer&, CORBA::TypeId buf, Long length
    );
    CORBA::Exception* get_exception(
	OxMarshalBuffer&, InterfaceDescriptor* d, ULong index
    );

    void save();
    void deactivate();

    struct export InterfaceList {
	InterfaceDescriptor** list;
	Long length;
    };

    struct export InterfaceListList {
	InterfaceList* listlist;
	Long length;
	Long used;
	InterfaceDescriptor* cache[16][2];
    };

    struct export ServerList {
	Receiver* list;
	Long length;
    };

    struct export ServerListList {
	ServerList* listlist;
	Long length;
	Long used;
	Receiver* cache[16][2];
    };

    const InterfaceListList& types() { return types_; }
protected:
    InterfaceDescriptor* object_;
    InterfaceListList types_;
    ServerListList servers_;

    static OxSchema* schema_;
};

inline CORBA::Exception* OxSchema::get_exception(
    OxMarshalBuffer& mb, InterfaceDescriptor* d, ULong index
) {
    return (*(d->excepts[index - 1])->unmarshal)(mb);
}

//
// These classes are just for static initializers.
//

class export OxInitSchema {
public:
    OxInitSchema(OxSchema::InterfaceDescriptor**, Long length);
    ~OxInitSchema();
};

class export OxInitServer {
public:
    OxInitServer(OxSchema::Receiver*, Long length);
    ~OxInitServer();
};

class export OxTypeImpl : public CORBA::Type {
public:
    OxTypeImpl(OxSchema::TypeDescriptorPtr);
    ~OxTypeImpl();

    OxExchange* _exchange();

    char* name();
    TCKind kind();
    Boolean op_info(CORBA::Type::OpInfo& op, Long n);
    Long enum_info();
    void array_info(CORBA::Type_out type, Long& size);
    Long members();
    CORBA::Type_ptr member_info(Long n);
    void sequence_info(CORBA::Type_out type, Long& size);
    CORBA::Type_ptr typedef_info();

    static OxTypeImpl* make_type(OxSchema::TypeDescriptorPtr);
    static OxTypeImpl* make_type(OxSchema::InterfaceDescriptor* d) {
	return make_type((OxSchema::TypeDescriptor*)d);
    }
protected:
    OxLibraryExchange exchange_;
    OxSchema::TypeDescriptor* descriptor_;
    Long opcount_;
};

//
// Define the default case for a method switch.
//

// should generate an error
#define _Ix_BadMethod(m) \
    break

//
// Define the type descriptor for a given type.
//

#define _Ix_tid(T) _Ix_concat(T,_tid)
#define _Ix__tid(T) _Ix_concat(_,_Ix_concat(T,_tid))
#define _Ix_type(T) _Ix_concat(T,_type)
#define _Ix__type(T) _Ix_concat(_,_Ix_concat(T,_type))
#define _Ix_extern__tid(Q) extern ULong _Ix__tid(Q)[]
#define _Ix__parents(T) _Ix_concat(_,_Ix_concat(T,_parents))
#define _Ix__excepts(T) _Ix_concat(_,_Ix_concat(T,_excepts))
#define _Ix__receive(T) _Ix_concat(_,_Ix_concat(T,_receive))
#define _Ix__methods(T) _Ix_concat(_,_Ix_concat(T,_methods))
#define _Ix__params(T) _Ix_concat(_,_Ix_concat(T,_params))
#define _Ix__subscripts(T) _Ix_concat(_,_Ix_concat(T,_subscripts))
#define _Ix__members(T) _Ix_concat(_,_Ix_concat(T,_members))
#define _Ix__cases(T) _Ix_concat(_,_Ix_concat(T,_cases))
#define _Ix_array(T1,T2) _Ix_concat(T1,_Ix_concat(_array_,T2))
#define _Ix_extern__receiver(Q) \
extern void _Ix__receive(Q)( \
    CORBA::Object_ptr, ULong, OxMarshalBuffer&, OxMarshalBuffer& \
)

#define _Ix_extern_server(Q) \
_Ix_extern__tid(Q); \
_Ix_extern__receiver(Q)

#define _Ix__xid(E) _Ix_concat(_,_Ix_concat(E,_xid_))
#define _Ix_extern_xid(E) extern OxExchangeId _Ix__xid(E)

//
// Generate unique symbol so that cfront-based compilers use this
// when generating per-file externals.
//

#define _Ix_FileId(name) \
char name = 0;

#define _Ix_ExternParent(Q) extern import OxSchema::InterfaceDescriptor _Ix__type(Q)

#define _Ix_BeginParentList(Q) \
OxSchema::InterfaceDescriptor* _Ix__parents(Q)[] = {

#define _Ix_ParentEntry(Q) \
    &_Ix__type(Q)

#define _Ix_EndParentList() \
    0 \
};

#define _Ix_BeginMethodList(Q) \
OxSchema::OperationData _Ix_concat(Q,_methods)[] = {

#define _Ix_EndMethodList() \
    { 0, 0, 0 } \
};

#define _Ix_BeginParamList(Q) \
OxSchema::ParameterData _Ix_concat(Q,_params)[] = {

#define _Ix_EndParamList() \
};

#define _Ix_CommonInterfaceDescriptor(Q,Name,parents,excepts) \
_Ix_extern__tid(Q); \
export OxSchema::InterfaceDescriptor _Ix__type(Q) = {\
    { Name, CORBA::Type::tk_objref, /* type */ 0 }, \
    /* id */ _Ix__tid(Q), \
    /* parents */ parents, \
    /* excepts */ excepts,

#define _Ix_InterfaceDescriptor(Q,Name,parents,excepts) \
_Ix_CommonInterfaceDescriptor(Q,Name,parents,excepts) \
    /* methods */ nil, \
    /* params */ nil \
}

#define _Ix_InterfaceDescriptorDII(Q,Name,parents,excepts) \
extern void _Ix__receive(Q)( \
    CORBA::Object_ptr, CORBA::ULong, OxMarshalBuffer&, OxMarshalBuffer& \
); \
_Ix_CommonInterfaceDescriptor(Q,Name,parents,excepts) \
    /* methods */ _Ix__methods(Q), \
    /* params */ _Ix__params(Q) \
}

#define _Ix_TypedefDescriptor(Q,Name,T) \
export OxSchema::TypedefDescriptor _Ix__type(Q) = {\
    { Name, CORBA::Type::tk_TypeCode, /* type */ 0 }, \
    &_Ix__type(T) \
}

#define _Ix_BeginSubscriptList(Name) \
Long _Ix__subscripts(Name)[] = {

#define _Ix_EndSubscriptList() \
};

#define _Ix_EnumDescriptor(Q,Name,N) \
export OxSchema::EnumDescriptor _Ix__type(Q) = { \
    { Name, CORBA::Type::tk_enum, /* type */ 0 }, \
    /* count */ N \
}

#define _Ix_ArrayDescriptor(T,E,N) \
export OxSchema::ArrayDescriptor _Ix__type(T) = { \
    { 0, CORBA::Type::tk_array, /* type */ 0 }, \
    /* element */ &_Ix__type(E), \
    /* number of subscripts */ N, \
    /* subscripts */ _Ix__subscripts(T), \
}

#define _Ix_BeginMemberList(Q) \
static OxSchema::TypeDescriptorPtr _Ix__members(Q)[] = {

#define _Ix_EndMemberList() \
};

#define _Ix_StructDescriptor(D,Name,Q,N) \
export OxSchema::StructDescriptor _Ix__type(D) = { \
    { Name, CORBA::Type::tk_struct, /* type */ 0 }, \
    /* number of members */ N, \
    /* members */ _Ix__members(D) \
}

#define _Ix_EmptyStructDescriptor(D,Name,Q) \
export OxSchema::StructDescriptor _Ix__type(D) = { \
    { Name, CORBA::Type::tk_struct, /* type */ 0 }, \
    /* number of members */ 0, \
    /* members */ 0 \
}

#define _Ix_BeginCaseList(Q) \
static Long _Ix__cases(Q)[] = {

#define _Ix_EndCaseList() \
};

#define _Ix_UnionDescriptor(D,Name,Q,T,N) \
export OxSchema::UnionDescriptor _Ix__type(D) = { \
    { Name, CORBA::Type::tk_union, /* type */ 0 }, \
    /* tag */ &_Ix__type(T), \
    /* number of members */ N, \
    /* cases */ _Ix__cases(D), \
    /* members */ _Ix__members(D) \
}

#define _Ix_SequenceDescriptor(D,Name,Q,T) \
export OxSchema::SequenceDescriptor _Ix__type(D) = { \
    { Name, /* kind */ CORBA::Type::tk_sequence, /* type */ 0 }, \
    /* element */ &_Ix__type(T) \
}

#define _Ix_ExceptDescriptor(D,Name,Q,N) \
export OxSchema::ExceptDescriptor _Ix__type(D) = { \
    { Name, CORBA::Type::tk_except, /* type */ 0 }, \
    /* number of members */ 0, \
    /* members */ 0, \
    /* unmarshal */ &Q::_get \
}

#define _Ix_ExceptDescriptorDII(D,Name,Q,N) \
export OxSchema::ExceptDescriptor _Ix__type(D) = { \
    { Name, CORBA::Type::tk_except, /* type */ 0 }, \
    /* number of members */ N, \
    /* members */ _Ix__members(D), \
    /* unmarshal */ &Q::_get \
}

#define _Ix_EmptyExceptDescriptor(D,Name,Q) \
export OxSchema::ExceptDescriptor _Ix__type(D) = { \
    { Name, CORBA::Type::tk_except, /* type */ 0 }, \
    /* number of members */ 0, \
    /* members */ 0, \
    /* unmarshal */ &Q::_get \
}

#define _Ix_EmptyExceptDescriptorDII(D,Name,Q) \
_Ix_EmptyExceptDescriptor(D,Name,Q)

#define _Ix_BeginSchemaList() \
static OxSchema::InterfaceDescriptor* _ix_schema[] = {

#define _Ix_SchemaEntry(Q) \
    &_Ix__type(Q)

#define _Ix_EndSchemaList() \
}; \
\
static OxInitSchema _ix_init_schema( \
    _ix_schema, sizeof(_ix_schema) / sizeof(_ix_schema[0]) \
);

#define _Ix_BeginServerList() \
static OxSchema::Receiver _ix_server[] = {

#define _Ix_ServerEntry(Q) \
    { _Ix__tid(Q), &_Ix__receive(Q) }

#define _Ix_EndServerList() \
}; \
\
static OxInitServer _ix_init_server( \
    _ix_server, sizeof(_ix_server) / sizeof(_ix_server[0]) \
);

#define _Ix_ExternExceptionTable(D) \
extern import OxSchema::ExceptDescriptor* _Ix__excepts(D)[]

#define _Ix_BeginExceptionTable(D) \
OxSchema::ExceptDescriptor* _Ix__excepts(D)[] = {

#define _Ix_ExceptionEntry(D) \
    &_Ix__type(D)

#define _Ix_EndExceptionTable() \
};

#define _Ix_DefineTypeId(T,N) \
ULong _Ix__tid(T)[1] = { (IX_TID_SHORT << 28) | N }

#define _Ix_DefineExchangeId(E,N) \
OxExchangeId _Ix__xid(E) = N

//
// Short-hand for simple type descriptors that don't have a type id.
//

#define _Ix_DefineType(Name,kind,StringName) \
export OxSchema::TypedefDescriptor _Ix__type(Name) = { \
    { StringName, CORBA::Type::kind, 0 }, 0 \
};

#endif
