//
// $XConsortium$
//

//
// Copyright (c) 1993 Silicon Graphics, Inc.
// Copyright (c) 1993 Fujitsu, Ltd.
//
// Permission to use, copy, modify, distribute, and sell this software and 
// its documentation for any purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the names of
// Silicon Graphics and Fujitsu may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Silicon Graphics and Fujitsu.
//
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
//
// IN NO EVENT SHALL SILICON GRAPHICS OR FUJITSU BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
//

#ifndef ox_transport_h
#define ox_transport_h

#include "base.h"

//
// Interface to routines that do transport across address spaces/network.
//

#if unix

#ifdef hpux
extern "C" {
#include <rpc/rpc.h>
}
#else
#include <rpc/rpc.h>
#endif

#else

// Since the current transport layer uses ONC RPC, we're out of luck
// for now on non-Unix platforms.
typedef char XDR;

#endif

//
// C-style interface for now because the underlying layers are C-based.
//

class OxMarshalBuffer;

extern int oxCall(const char* hostname, long port, void* buf);
extern int oxMarshal(XDR* xdrsp, OxMarshalBuffer*);
extern int oxUnmarshal(XDR* xdrsp, OxMarshalBuffer*);

#endif
