/*
 * Copyright (c) 1987-91 Stanford University
 * Copyright (c) 1991-93 Silicon Graphics, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * Stanford and Silicon Graphics may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Stanford and Silicon Graphics.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 *
 * IN NO EVENT SHALL STANFORD OR SILICON GRAPHICS BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef xf__scope_h
#define xf__scope_h

//
// Set up appropriate parameters for object system.
//

#ifndef OX_DII
#define OX_DII 1
#endif
#ifndef OX_RPC_EXCHANGE
#define OX_RPC_EXCHANGE 1
#endif
#include <Fresco/Ox/base.h>

#if !defined(UNIXCPP)
#define _lib_fresco(name) Xf##name
#else
#define _lib_fresco(name) Xf/**/name
#endif

#ifndef MAKEDEPEND

#include <Fresco/defs/_undefs.h>
#include <Fresco/defs/_defines.h>

#endif

//
// Have to repeat this here (nil is also defined by Ox/base.h) because
// we can't re-included base.h in sequence _enter.h, _leave.h, _enter.h.
//
#ifndef nil
#define nil 0
#endif

#endif
