/*
 * Copyright (c) 1995 Firefly Design
 * Copyright (c) 1995 Silicon Graphics, Inc.
 * Copyright (c) 1995 Fujitsu, Ltd.
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * Silicon Graphics and Fujitsu may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Silicon Graphics and Fujitsu.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 *
 * IN NO EVENT SHALL SILICON GRAPHICS OR FUJITSU BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#include <Fresco/Ox/schema.h>

#include <Fresco/defs_Mac/MacCursor.h>

// class MacCursor

//+ MacCursor(MacCursor)
void* MacCursor::_this_ptr() { return this; }
_Ix_extern__tid(MacCursor);
void* MacCursor::_narrow_tid(CORBA::TypeId t) {
    if (_Ix__tid(MacCursor) == t) return this;
    void* p;
    if (p = XfCursor::_narrow_tid(t)) return p;
    return nil;
};
_Ix_extern__tid(MacCursor);
_Ix_ImplementGetTid(MacCursor,_Ix__tid(MacCursor))
_Ix_ImplementNarrow(MacCursor*,MacCursor,_Ix_NullParameter,MacCursor,0)
_Ix_ImplementDuplicate(MacCursor*,MacCursor,_Ix_NullParameter,_Ix__tid(MacCursor),0)
//+

MacCursor::MacCursor(
    short /* x */, short /* y */, long /* pattern */ [16], long /* mask */ [16]
) {
    /* not implemented */
    cursor_ = nil;
}

MacCursor::MacCursor(Raster_ptr /* bitmap */, Raster_ptr /* mask */) {
    /* not implemented */
    cursor_ = nil;
}

MacCursor::MacCursor(Font_ptr /* f */, long /* pattern */, long /* mask */) {
    /* not implemented */
    cursor_ = nil;
}

MacCursor::MacCursor(long index) {
    // Assume that index is a resource identifier.
    cursor_ = GetCCursor(index);
}

MacCursor::~MacCursor() { 
    if (cursor_) {
	    DisposeCCursor(cursor_);
    }
}

OxExchange* MacCursor::_exchange() { return &object_; }

//+ MacCursor(XfFrescoObject::=object_.)
XfTag MacCursor::attach(XfFrescoObject_ptr observer) {
    return object_.attach(observer);
}
void MacCursor::detach(XfTag attach_tag) {
    object_.detach(attach_tag);
}
void MacCursor::disconnect() {
    object_.disconnect();
}
void MacCursor::notify_observers() {
    object_.notify_observers();
}
void MacCursor::update() {
    object_.update();
}
//+
