/*
 * Copyright (c) 1995 Firefly Design
 * Copyright (c) 1995 Silicon Graphics, Inc.
 * Copyright (c) 1995 Fujitsu, Ltd.
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * Silicon Graphics and Fujitsu may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Silicon Graphics and Fujitsu.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 *
 * IN NO EVENT SHALL SILICON GRAPHICS OR FUJITSU BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef MacScreen_h
#define MacScreen_h

#include <Fresco/defs/display.h>

#include <Fresco/defs_impl/fobjects.h>

class MacDisplay;

//+ MacScreen : XfScreen
class MacScreen : public XfScreen {
public:
    ~MacScreen();
    _Ix_InterfaceOps(MacScreen*)
//+
public:
    MacScreen(MacDisplay*, long n);
    OxExchange* _exchange();

    //+ XfScreen::*
    /* XfFrescoObject */
    XfTag attach(XfFrescoObject_ptr observer);
    void detach(XfTag attach_tag);
    void disconnect();
    void notify_observers();
    void update();
    /* XfScreen */
    XfCoord dpi();
    void dpi(XfCoord _p);
    XfDisplay_ptr display_ptr();
    XfCoord width();
    XfCoord height();
    XfPixelCoord to_pixels(XfCoord c, XfAxis a);
    XfCoord to_coord(XfPixelCoord p, XfAxis a);
    XfCoord to_pixels_coord(XfCoord c, XfAxis a);
    void move_pointer(XfCoord x, XfCoord y);
    XfWindow_ptr application(XfViewer_ptr v);
    XfWindow_ptr top_level(XfViewer_ptr v, XfWindow_ptr group_leader);
    XfWindow_ptr transient(XfViewer_ptr v, XfWindow_ptr transient_for);
    XfWindow_ptr popup(XfViewer_ptr v);
    XfWindow_ptr icon(XfViewer_ptr v);
    //+

private:
    SharedFrescoObjectImpl object_;
    MacDisplay* display_;
    long number_;
    Coord width_;
    Coord height_;

    float x_pixel_;
    float y_pixel_;
    float x_point_;
    float y_point_;
};

#endif
