/*
 * Copyright (c) 1995 Firefly Design
 * Copyright (c) 1993-95 Silicon Graphics, Inc.
 * Copyright (c) 1993-95 Fujitsu, Ltd.
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * Silicon Graphics and Fujitsu may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Silicon Graphics and Fujitsu.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 *
 * IN NO EVENT SHALL SILICON GRAPHICS OR FUJITSU BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */


#ifndef Fresco_Impls_Wcursor_h
#define Fresco_Impls_Wcursor_h

#include <Fresco/defs/display.h>

#include <Fresco/defs_impl/fobjects.h>

#include <Fresco/defs_Win32/Wlib.h>

//+ Win32Cursor : XfCursor
class Win32Cursor : public XfCursor {
public:
    ~Win32Cursor();
    _Ix_InterfaceOps(Win32Cursor*)
//+
public:
    Win32Cursor(short x, short y, long pattern[16], long mask[16]);
    Win32Cursor(Raster_ptr bitmap, Raster_ptr mask);
    Win32Cursor(Font_ptr f, long pattern, long mask);
    Win32Cursor(long index);
    OxExchange* _exchange();

    //+ XfCursor::*
    /* XfFrescoObject */
    XfTag attach(XfFrescoObject_ptr observer);
    void detach(XfTag attach_tag);
    void disconnect();
    void notify_observers();
    void update();
    /* XfCursor */
    //+

    HCURSOR handle() const { return cursor_; }

private:
    SharedFrescoObjectImpl object_;
    HCURSOR cursor_;
};

#endif
