/*
 * Copyright (c) 1995 Firefly Design
 * Copyright (c) 1993-95 Silicon Graphics, Inc.
 * Copyright (c) 1993-95 Fujitsu, Ltd.
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * Silicon Graphics and Fujitsu may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Silicon Graphics and Fujitsu.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 *
 * IN NO EVENT SHALL SILICON GRAPHICS OR FUJITSU BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef Fresco_Impls_Wevent_h
#define Fresco_Impls_Wevent_h

#include <Fresco/defs/display.h>

#include <Fresco/defs_impl/fobjects.h>

#include <Fresco/defs_Win32/Wlib.h>

class Win32Display;
class Win32Window;

class Win32Event : public XfEvent {
public:
    Win32Event(
        Window_ptr window, HWND hwnd, UINT msg, WPARAM, LPARAM
    );
    ~Win32Event();

    _Ix_InterfaceOps(Win32Event*)
    OxExchange* _exchange();

    //+ XfEvent::*
    /* XfFrescoObject */
    XfTag attach(XfFrescoObject_ptr observer);
    void detach(XfTag attach_tag);
    void disconnect();
    void notify_observers();
    void update();
    /* XfEvent */
    XfEvent::TypeId type();
    XfEvent::TimeStamp time();
    Boolean double_click(XfEvent::TimeStamp previous);
    Boolean positional();
    Boolean hits(XfViewer_ptr v);
    XfCoord pointer_x();
    XfCoord pointer_y();
    XfEvent::ButtonIndex pointer_button();
    Boolean button_is_down(XfEvent::ButtonIndex b);
    Boolean modifier_is_down(XfEvent::Modifier m);
    XfEvent::KeySym key();
    XfCharCode character();
    void unread();
    //+

    HWND hWnd() { return hWnd_; }
    UINT message() { return message_; }
    WPARAM wParam() { return wParam_; }
    LPARAM lParam() { return lParam_; }

private:
    SharedFrescoObjectImpl object_;
    Window_ptr window_;
    HWND hWnd_;
    UINT message_;
    WPARAM wParam_;
    LPARAM lParam_;
    LONG time_;
    BYTE key_state_[256];
};

#endif
