/*
 * Copyright (c) 1995 Firefly Design
 * Copyright (c) 1993-95 Silicon Graphics, Inc.
 * Copyright (c) 1993-95 Fujitsu, Ltd.
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * Silicon Graphics and Fujitsu may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Silicon Graphics and Fujitsu.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 *
 * IN NO EVENT SHALL SILICON GRAPHICS OR FUJITSU BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

/*
 * interface to MS-Windows
 */

#ifndef Fresco_Wlib_h
#define Fresco_Wlib_h

#include <afxwin.h>
// #include <windows.h>

// --- conflict between OS/math and MS-Windows ----
#ifdef min
#undef min
#endif
#ifdef max
#undef max
#endif

void mwAssertion(const char* msg, const char* file, unsigned int line);
#ifdef NO_FRESCO_DEBUG
#define MWassert(test) ((void) 0)
#else
#define MWassert(test) ((void)((test) || (mwAssertion(#test,__FILE__,__LINE__),1)))
#endif

#include <Fresco/defs/types.h>

// Converts a Coordinate to TWIPS, which is what is expected for most
// of the Windows operations (ie those using logical coordinates
// where the mapping mode has been set to MM_TWIPS).
inline int coord_to_twips(Coord c) {
//    return int(c * 20.0 + ((c > 0) ? 0.5 : -0.5));
    return int(c * 20.0);
}

inline Coord twips_to_coord(int t) {
    return Coord(t / 20.0);
}

inline Coord twips_to_coord(FLOAT t) {
    return Coord(t / 20.0);
}

#endif /* Fresco_Wlib_h */
