//
// $XConsortium$
//

//
// Copyright (c) 1987-91 Stanford University
// Copyright (c) 1991-94 Silicon Graphics, Inc.
//
// Permission to use, copy, modify, distribute, and sell this software and 
// its documentation for any purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the names of
// Stanford and Silicon Graphics may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Stanford and Silicon Graphics.
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
//
// IN NO EVENT SHALL STANFORD OR SILICON GRAPHICS BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
//

#ifndef Fresco_defs_X11_Xevent_h
#define Fresco_defs_X11_Xevent_h

#include <Fresco/defs/display.h>
#include <Fresco/defs_impl/fobjects.h>
#include <Fresco/defs_X11/Xlib.h>

class DisplayImpl;

//+ EventImpl : XfEvent
class EventImpl : public XfEvent {
public:
    ~EventImpl();
    _Ix_InterfaceOps(EventImpl*)
//+
public:
    EventImpl(DisplayImpl*);

    OxExchange* _exchange();

    //+ XfEvent::*
    /* XfFrescoObject */
    XfTag attach(XfFrescoObject_ptr observer);
    void detach(XfTag attach_tag);
    void disconnect();
    void notify_observers();
    void update();
    /* XfEvent */
    XfEvent::TypeId type();
    XfEvent::TimeStamp time();
    Boolean double_click(XfEvent::TimeStamp previous);
    Boolean positional();
    Boolean hits(XfViewer_ptr v);
    XfCoord pointer_x();
    XfCoord pointer_y();
    XfEvent::ButtonIndex pointer_button();
    Boolean button_is_down(XfEvent::ButtonIndex b);
    Boolean modifier_is_down(XfEvent::Modifier m);
    XfEvent::KeySym key();
    XfCharCode character();
    void unread();
    //+

    XEvent xevent_;
    Window_ptr window_;

    void clear();
    void locate();
    unsigned int keymask();
protected:
    SharedFrescoObjectImpl object_;
    DisplayImpl* display_;
    Coord x_, y_, root_x_, root_y_;
    Boolean location_valid_;
};

#endif
