//
// $XConsortium$
//

//
// Copyright (c) 1992-94 Silicon Graphics, Inc.
//
// Permission to use, copy, modify, distribute, and sell this software and 
// its documentation for any purpose is hereby granted without fee,
// provided that (i) the above copyright notices and this permission notice
// appear in all copies of the software and related documentation, and
// (ii) the name of Silicon Graphics may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Silicon Graphics.
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
//
// IN NO EVENT SHALL SILICON GRAPHICS BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
//

#ifndef Fresco_defs_impl_names_h
#define Fresco_defs_impl_names_h

//
// Library access to naming services.
//

#include <Fresco/defs_impl/naming.h>

//- NamingLib*
class export NamingLib {
    //. NamingLib is a library interface to access naming system services.
public:
    //- current_context
    static void current_context(Naming::NamingContext_ptr);
    static Naming::NamingContext_ptr current_context();
	//. Set or get the current naming context that is used to access
	//. naming system services.  These operations assume that
	//. the object reference is statically allocated, and as such
	//. no memory management is implied.  The caller therefore should not
	//. release the returned kit object reference.

    //- to_name, to_string
    static Naming::Name* to_name(const char* str);
    static char* to_string(const Naming::Name& name);
	//. Convert between strings and names.  The conversion
	//. currently treats slash ('/') as the separator between
	//. name components and creates empty kind strings.

    //- set_component
    static void set_component(
	Naming::NameComponent& comp, const char* str, unsigned int length
    );
protected:
    static Naming::NamingContext_ptr context_;
};

#endif
