//
// $XConsortium$
//

//
// Copyright (c) 1991 Stanford University
// Copyright (c) 1991-94 Silicon Graphics, Inc.
// Copyright (c) 1993-94 Fujitsu, Ltd.
//
// Permission to use, copy, modify, distribute, and sell this software and 
// its documentation for any purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the names
// of Stanford, Silicon Graphics, and Fujitsu may not be used in any
// advertising or publicity relating to the software without the specific,
// prior written permission of Stanford, Silicon Graphics, and Fujitsu.
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
//
// IN NO EVENT SHALL STANFORD, SILICON GRAPHICS, OR FUJITSU BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
//

#include <stdlib.h>
#include <string.h>
#include <Fresco/Ox/schema.h>
#include <Fresco/Ox/marshal.h>
#include <Fresco/defs_impl/fobjects.h>
#include <Fresco/defs_impl/list.h>
#include <Fresco/defs_impl/threads.h>
#include <Fresco/defs_impl/thread.h>

//+ XfThreadKit::%init,type-funcs,client,server
XfThreadKit::XfThreadKit() { }
XfThreadKit::~XfThreadKit() { }
void* XfThreadKit::_this_ptr() { return this; }
_Ix_extern__tid(XfThreadKit);
void* XfThreadKit::_narrow_tid(CORBA::TypeId t) {
    if (_Ix__tid(XfThreadKit) == t) return this;
    if (CORBA::Object::_type_id() == t) return (CORBA::Object*) this;
    return nil;
};
_Ix_ImplementField(XfThreadKit,XfThreadKit,_Ix_NullParameter)

_Ix_extern__tid(XfThreadKit);
_Ix_ExternProxy(XfThreadKit);
_Ix_ImplementGetTid(XfThreadKit,_Ix__tid(XfThreadKit))
_Ix_ImplementNarrow(XfThreadKit_ptr,XfThreadKit,_Ix_NullParameter,XfThreadKit,&_Ix_CreateProxy(XfThreadKit))
_Ix_ImplementDuplicate(XfThreadKit_ptr,XfThreadKit,_Ix_NullParameter,_Ix__tid(XfThreadKit),&_Ix_CreateProxy(XfThreadKit))
_Ix_ExternProxy(XfThread);
_Ix_ExternProxy(XfAction);
_Ix_ExternProxy(XfMutex);
_Ix_ExternProxy(XfConditionVariable);
_Ix_ExternProxy(XfSemaphore);
_Ix_ImplementProxy(XfThreadKit,XfThreadKit,XfThreadKit)
_Ix_MarshalBuffer::ArgDesc _XfThreadKit_thread_ptr_pdesc[3] = { 2, 60, 61 };
_Ix_MarshalBuffer::ArgMarshal _XfThreadKit_thread_ptr_pfunc[] = {
    &_Ix_CreateProxy(XfAction),
    &_Ix_CreateProxy(XfThread)
};
_Ix_MarshalBuffer::ArgInfo _XfThreadKit_thread_ptr_pinfo = {
    _XfThreadKit_tid, 0, _XfThreadKit_thread_ptr_pdesc, _XfThreadKit_thread_ptr_pfunc
};
XfThread_ptr XfThreadKit::thread_ptr(XfAction_ptr a) {
    _Ix_MarshalBuffer _b;
    _Ix_MarshalBuffer::ArgValue _arg[2];
    _arg[1].u_objref = a;
    _b.invoke(this, _XfThreadKit_thread_ptr_pinfo, _arg);
    return (XfThread_ptr)_arg[0].u_vaddr;
}
_Ix_MarshalBuffer::ArgDesc _XfThreadKit_mutex_ptr_pdesc[2] = { 1, 60 };
_Ix_MarshalBuffer::ArgMarshal _XfThreadKit_mutex_ptr_pfunc[] = {
    &_Ix_CreateProxy(XfMutex)
};
_Ix_MarshalBuffer::ArgInfo _XfThreadKit_mutex_ptr_pinfo = {
    _XfThreadKit_tid, 1, _XfThreadKit_mutex_ptr_pdesc, _XfThreadKit_mutex_ptr_pfunc
};
XfMutex_ptr XfThreadKit::mutex_ptr() {
    _Ix_MarshalBuffer _b;
    _Ix_MarshalBuffer::ArgValue _arg[1];
    _b.invoke(this, _XfThreadKit_mutex_ptr_pinfo, _arg);
    return (XfMutex_ptr)_arg[0].u_vaddr;
}
_Ix_MarshalBuffer::ArgDesc _XfThreadKit_condition_pdesc[2] = { 1, 60 };
_Ix_MarshalBuffer::ArgMarshal _XfThreadKit_condition_pfunc[] = {
    &_Ix_CreateProxy(XfConditionVariable)
};
_Ix_MarshalBuffer::ArgInfo _XfThreadKit_condition_pinfo = {
    _XfThreadKit_tid, 2, _XfThreadKit_condition_pdesc, _XfThreadKit_condition_pfunc
};
XfConditionVariable_ptr XfThreadKit::condition() {
    _Ix_MarshalBuffer _b;
    _Ix_MarshalBuffer::ArgValue _arg[1];
    _b.invoke(this, _XfThreadKit_condition_pinfo, _arg);
    return (XfConditionVariable_ptr)_arg[0].u_vaddr;
}
_Ix_MarshalBuffer::ArgDesc _XfThreadKit_general_semaphore_pdesc[3] = { 2, 60, 33 };
_Ix_MarshalBuffer::ArgMarshal _XfThreadKit_general_semaphore_pfunc[] = {
    &_Ix_CreateProxy(XfSemaphore)
};
_Ix_MarshalBuffer::ArgInfo _XfThreadKit_general_semaphore_pinfo = {
    _XfThreadKit_tid, 3, _XfThreadKit_general_semaphore_pdesc, _XfThreadKit_general_semaphore_pfunc
};
XfSemaphore_ptr XfThreadKit::general_semaphore(Long count) {
    _Ix_MarshalBuffer _b;
    _Ix_MarshalBuffer::ArgValue _arg[2];
    _arg[1].u_long = count;
    _b.invoke(this, _XfThreadKit_general_semaphore_pinfo, _arg);
    return (XfSemaphore_ptr)_arg[0].u_vaddr;
}
_Ix_MarshalBuffer::ArgDesc _XfThreadKit_mutex_semaphore_pdesc[2] = { 1, 60 };
_Ix_MarshalBuffer::ArgMarshal _XfThreadKit_mutex_semaphore_pfunc[] = {
    &_Ix_CreateProxy(XfSemaphore)
};
_Ix_MarshalBuffer::ArgInfo _XfThreadKit_mutex_semaphore_pinfo = {
    _XfThreadKit_tid, 4, _XfThreadKit_mutex_semaphore_pdesc, _XfThreadKit_mutex_semaphore_pfunc
};
XfSemaphore_ptr XfThreadKit::mutex_semaphore() {
    _Ix_MarshalBuffer _b;
    _Ix_MarshalBuffer::ArgValue _arg[1];
    _b.invoke(this, _XfThreadKit_mutex_semaphore_pinfo, _arg);
    return (XfSemaphore_ptr)_arg[0].u_vaddr;
}
_Ix_MarshalBuffer::ArgDesc _XfThreadKit_wait_semaphore_pdesc[2] = { 1, 60 };
_Ix_MarshalBuffer::ArgMarshal _XfThreadKit_wait_semaphore_pfunc[] = {
    &_Ix_CreateProxy(XfSemaphore)
};
_Ix_MarshalBuffer::ArgInfo _XfThreadKit_wait_semaphore_pinfo = {
    _XfThreadKit_tid, 5, _XfThreadKit_wait_semaphore_pdesc, _XfThreadKit_wait_semaphore_pfunc
};
XfSemaphore_ptr XfThreadKit::wait_semaphore() {
    _Ix_MarshalBuffer _b;
    _Ix_MarshalBuffer::ArgValue _arg[1];
    _b.invoke(this, _XfThreadKit_wait_semaphore_pinfo, _arg);
    return (XfSemaphore_ptr)_arg[0].u_vaddr;
}
_Ix_ReceiveHdr(XfThreadKit,_b_receive,_b_reply) {
    _Ix_CastReceiver(XfThreadKit_ptr,XfThreadKit);
    _Ix_MarshalBuffer::ArgValue _arg[2];
    _Ix_MarshalBuffer::ArgInfo* _arginfo;
    switch (_m) {
        case /* thread_ptr */ 0: {
            extern _Ix_MarshalBuffer::ArgInfo _XfThreadKit_thread_ptr_pinfo;
            _arginfo = &_XfThreadKit_thread_ptr_pinfo;
            XfAction_ptr a;
            _arg[1].u_addr = &a;
            if (_b_receive.receive(_XfThreadKit_thread_ptr_pinfo, _arg)) {
                a = XfAction::_narrow((CORBA::Object_ptr)(void*)a);
                _arg[0].u_objref = _this->thread_ptr(a);
            }
            _b_reply.reply(*_arginfo, _arg);
            break;
        }
        case /* mutex_ptr */ 1: {
            extern _Ix_MarshalBuffer::ArgInfo _XfThreadKit_mutex_ptr_pinfo;
            _arginfo = &_XfThreadKit_mutex_ptr_pinfo;
            _arg[0].u_objref = _this->mutex_ptr();
            _b_reply.reply(*_arginfo, _arg);
            break;
        }
        case /* condition */ 2: {
            extern _Ix_MarshalBuffer::ArgInfo _XfThreadKit_condition_pinfo;
            _arginfo = &_XfThreadKit_condition_pinfo;
            _arg[0].u_objref = _this->condition();
            _b_reply.reply(*_arginfo, _arg);
            break;
        }
        case /* general_semaphore */ 3: {
            extern _Ix_MarshalBuffer::ArgInfo _XfThreadKit_general_semaphore_pinfo;
            _arginfo = &_XfThreadKit_general_semaphore_pinfo;
            Long count;
            _arg[1].u_addr = &count;
            if (_b_receive.receive(_XfThreadKit_general_semaphore_pinfo, _arg)) {
                _arg[0].u_objref = _this->general_semaphore(count);
            }
            _b_reply.reply(*_arginfo, _arg);
            break;
        }
        case /* mutex_semaphore */ 4: {
            extern _Ix_MarshalBuffer::ArgInfo _XfThreadKit_mutex_semaphore_pinfo;
            _arginfo = &_XfThreadKit_mutex_semaphore_pinfo;
            _arg[0].u_objref = _this->mutex_semaphore();
            _b_reply.reply(*_arginfo, _arg);
            break;
        }
        case /* wait_semaphore */ 5: {
            extern _Ix_MarshalBuffer::ArgInfo _XfThreadKit_wait_semaphore_pinfo;
            _arginfo = &_XfThreadKit_wait_semaphore_pinfo;
            _arg[0].u_objref = _this->wait_semaphore();
            _b_reply.reply(*_arginfo, _arg);
            break;
        }
        default:
            _Ix_BadMethod(_m);
    }
}
//+

//+ XfThread::%init,type-funcs,client,server
XfThread::XfThread() { }
XfThread::~XfThread() { }
void* XfThread::_this_ptr() { return this; }
_Ix_extern__tid(XfThread);
void* XfThread::_narrow_tid(CORBA::TypeId t) {
    if (_Ix__tid(XfThread) == t) return this;
    if (CORBA::Object::_type_id() == t) return (CORBA::Object*) this;
    return nil;
};
_Ix_ImplementField(XfThread,XfThread,_Ix_NullParameter)

_Ix_extern__tid(XfThread);
_Ix_ExternProxy(XfThread);
_Ix_ImplementGetTid(XfThread,_Ix__tid(XfThread))
_Ix_ImplementNarrow(XfThread_ptr,XfThread,_Ix_NullParameter,XfThread,&_Ix_CreateProxy(XfThread))
_Ix_ImplementDuplicate(XfThread_ptr,XfThread,_Ix_NullParameter,_Ix__tid(XfThread),&_Ix_CreateProxy(XfThread))
_Ix_ImplementProxy(XfThread,XfThread,XfThread)
_Ix_MarshalBuffer::ArgDesc _XfThread_run_pdesc[2] = { 1, 4 };
_Ix_MarshalBuffer::ArgInfo _XfThread_run_pinfo = {
    _XfThread_tid, 0, _XfThread_run_pdesc, 0
};
void XfThread::run() {
    _Ix_MarshalBuffer _b;
    _Ix_MarshalBuffer::ArgValue _arg[1];
    _b.invoke(this, _XfThread_run_pinfo, _arg);
}
_Ix_MarshalBuffer::ArgDesc _XfThread_terminate_pdesc[2] = { 1, 4 };
_Ix_MarshalBuffer::ArgInfo _XfThread_terminate_pinfo = {
    _XfThread_tid, 1, _XfThread_terminate_pdesc, 0
};
void XfThread::terminate() {
    _Ix_MarshalBuffer _b;
    _Ix_MarshalBuffer::ArgValue _arg[1];
    _b.invoke(this, _XfThread_terminate_pinfo, _arg);
}
_Ix_MarshalBuffer::ArgDesc _XfThread_wait_pdesc[4] = { 3, 4, 34, 34 };
_Ix_MarshalBuffer::ArgInfo _XfThread_wait_pinfo = {
    _XfThread_tid, 2, _XfThread_wait_pdesc, 0
};
void XfThread::wait(Long& status, Long& exitcode) {
    _Ix_MarshalBuffer _b;
    _Ix_MarshalBuffer::ArgValue _arg[3];
    _arg[1].u_addr = &status;
    _arg[2].u_addr = &exitcode;
    _b.invoke(this, _XfThread_wait_pinfo, _arg);
}
_Ix_ReceiveHdr(XfThread,_b_receive,_b_reply) {
    _Ix_CastReceiver(XfThread_ptr,XfThread);
    _Ix_MarshalBuffer::ArgValue _arg[3];
    _Ix_MarshalBuffer::ArgInfo* _arginfo;
    switch (_m) {
        case /* run */ 0: {
            extern _Ix_MarshalBuffer::ArgInfo _XfThread_run_pinfo;
            _arginfo = &_XfThread_run_pinfo;
            _this->run();
            _b_reply.reply(*_arginfo, _arg);
            break;
        }
        case /* terminate */ 1: {
            extern _Ix_MarshalBuffer::ArgInfo _XfThread_terminate_pinfo;
            _arginfo = &_XfThread_terminate_pinfo;
            _this->terminate();
            _b_reply.reply(*_arginfo, _arg);
            break;
        }
        case /* wait */ 2: {
            extern _Ix_MarshalBuffer::ArgInfo _XfThread_wait_pinfo;
            _arginfo = &_XfThread_wait_pinfo;
            Long status;
            _arg[1].u_addr = &status;
            Long exitcode;
            _arg[2].u_addr = &exitcode;
            if (_b_receive.receive(_XfThread_wait_pinfo, _arg)) {
                _this->wait(status, exitcode);
            }
            _b_reply.reply(*_arginfo, _arg);
            break;
        }
        default:
            _Ix_BadMethod(_m);
    }
}
//+

//+ XfMutex::%init,type-funcs,client,server
XfMutex::XfMutex() { }
XfMutex::~XfMutex() { }
void* XfMutex::_this_ptr() { return this; }
_Ix_extern__tid(XfMutex);
void* XfMutex::_narrow_tid(CORBA::TypeId t) {
    if (_Ix__tid(XfMutex) == t) return this;
    if (CORBA::Object::_type_id() == t) return (CORBA::Object*) this;
    return nil;
};
_Ix_ImplementField(XfMutex,XfMutex,_Ix_NullParameter)

_Ix_extern__tid(XfMutex);
_Ix_ExternProxy(XfMutex);
_Ix_ImplementGetTid(XfMutex,_Ix__tid(XfMutex))
_Ix_ImplementNarrow(XfMutex_ptr,XfMutex,_Ix_NullParameter,XfMutex,&_Ix_CreateProxy(XfMutex))
_Ix_ImplementDuplicate(XfMutex_ptr,XfMutex,_Ix_NullParameter,_Ix__tid(XfMutex),&_Ix_CreateProxy(XfMutex))
_Ix_ImplementProxy(XfMutex,XfMutex,XfMutex)
_Ix_MarshalBuffer::ArgDesc _XfMutex_acquire_pdesc[2] = { 1, 4 };
_Ix_MarshalBuffer::ArgInfo _XfMutex_acquire_pinfo = {
    _XfMutex_tid, 0, _XfMutex_acquire_pdesc, 0
};
void XfMutex::acquire() {
    _Ix_MarshalBuffer _b;
    _Ix_MarshalBuffer::ArgValue _arg[1];
    _b.invoke(this, _XfMutex_acquire_pinfo, _arg);
}
_Ix_MarshalBuffer::ArgDesc _XfMutex_release_pdesc[2] = { 1, 4 };
_Ix_MarshalBuffer::ArgInfo _XfMutex_release_pinfo = {
    _XfMutex_tid, 1, _XfMutex_release_pdesc, 0
};
void XfMutex::release() {
    _Ix_MarshalBuffer _b;
    _Ix_MarshalBuffer::ArgValue _arg[1];
    _b.invoke(this, _XfMutex_release_pinfo, _arg);
}
_Ix_MarshalBuffer::ArgDesc _XfMutex_try_acquire_pdesc[2] = { 1, 12 };
_Ix_MarshalBuffer::ArgInfo _XfMutex_try_acquire_pinfo = {
    _XfMutex_tid, 2, _XfMutex_try_acquire_pdesc, 0
};
Boolean XfMutex::try_acquire() {
    _Ix_MarshalBuffer _b;
    _Ix_MarshalBuffer::ArgValue _arg[1];
    _b.invoke(this, _XfMutex_try_acquire_pinfo, _arg);
    return _arg[0].u_boolean;
}
_Ix_ReceiveHdr(XfMutex,_Ix_NullParameter,_b_reply) {
    _Ix_CastReceiver(XfMutex_ptr,XfMutex);
    _Ix_MarshalBuffer::ArgValue _arg[1];
    _Ix_MarshalBuffer::ArgInfo* _arginfo;
    switch (_m) {
        case /* acquire */ 0: {
            extern _Ix_MarshalBuffer::ArgInfo _XfMutex_acquire_pinfo;
            _arginfo = &_XfMutex_acquire_pinfo;
            _this->acquire();
            _b_reply.reply(*_arginfo, _arg);
            break;
        }
        case /* release */ 1: {
            extern _Ix_MarshalBuffer::ArgInfo _XfMutex_release_pinfo;
            _arginfo = &_XfMutex_release_pinfo;
            _this->release();
            _b_reply.reply(*_arginfo, _arg);
            break;
        }
        case /* try_acquire */ 2: {
            extern _Ix_MarshalBuffer::ArgInfo _XfMutex_try_acquire_pinfo;
            _arginfo = &_XfMutex_try_acquire_pinfo;
            _arg[0].u_boolean = _this->try_acquire();
            _b_reply.reply(*_arginfo, _arg);
            break;
        }
        default:
            _Ix_BadMethod(_m);
    }
}
//+

//+ XfConditionVariable::%init,type-funcs,client,server
XfConditionVariable::XfConditionVariable() { }
XfConditionVariable::~XfConditionVariable() { }
void* XfConditionVariable::_this_ptr() { return this; }
_Ix_extern__tid(XfConditionVariable);
void* XfConditionVariable::_narrow_tid(CORBA::TypeId t) {
    if (_Ix__tid(XfConditionVariable) == t) return this;
    if (CORBA::Object::_type_id() == t) return (CORBA::Object*) this;
    return nil;
};
_Ix_ImplementField(XfConditionVariable,XfConditionVariable,_Ix_NullParameter)

_Ix_extern__tid(XfConditionVariable);
_Ix_ExternProxy(XfConditionVariable);
_Ix_ImplementGetTid(XfConditionVariable,_Ix__tid(XfConditionVariable))
_Ix_ImplementNarrow(XfConditionVariable_ptr,XfConditionVariable,_Ix_NullParameter,XfConditionVariable,&_Ix_CreateProxy(XfConditionVariable))
_Ix_ImplementDuplicate(XfConditionVariable_ptr,XfConditionVariable,_Ix_NullParameter,_Ix__tid(XfConditionVariable),&_Ix_CreateProxy(XfConditionVariable))
_Ix_ImplementProxy(XfConditionVariable,XfConditionVariable,XfConditionVariable)
_Ix_MarshalBuffer::ArgDesc _XfConditionVariable_wait_pdesc[3] = { 2, 4, 61 };
_Ix_MarshalBuffer::ArgMarshal _XfConditionVariable_wait_pfunc[] = {
    &_Ix_CreateProxy(XfMutex),

};
_Ix_MarshalBuffer::ArgInfo _XfConditionVariable_wait_pinfo = {
    _XfConditionVariable_tid, 0, _XfConditionVariable_wait_pdesc, _XfConditionVariable_wait_pfunc
};
void XfConditionVariable::wait(XfMutex_ptr lock) {
    _Ix_MarshalBuffer _b;
    _Ix_MarshalBuffer::ArgValue _arg[2];
    _arg[1].u_objref = lock;
    _b.invoke(this, _XfConditionVariable_wait_pinfo, _arg);
}
_Ix_MarshalBuffer::ArgDesc _XfConditionVariable_notify_pdesc[2] = { 1, 4 };
_Ix_MarshalBuffer::ArgInfo _XfConditionVariable_notify_pinfo = {
    _XfConditionVariable_tid, 1, _XfConditionVariable_notify_pdesc, 0
};
void XfConditionVariable::notify() {
    _Ix_MarshalBuffer _b;
    _Ix_MarshalBuffer::ArgValue _arg[1];
    _b.invoke(this, _XfConditionVariable_notify_pinfo, _arg);
}
_Ix_MarshalBuffer::ArgDesc _XfConditionVariable_broadcast_pdesc[2] = { 1, 4 };
_Ix_MarshalBuffer::ArgInfo _XfConditionVariable_broadcast_pinfo = {
    _XfConditionVariable_tid, 2, _XfConditionVariable_broadcast_pdesc, 0
};
void XfConditionVariable::broadcast() {
    _Ix_MarshalBuffer _b;
    _Ix_MarshalBuffer::ArgValue _arg[1];
    _b.invoke(this, _XfConditionVariable_broadcast_pinfo, _arg);
}
_Ix_ReceiveHdr(XfConditionVariable,_b_receive,_b_reply) {
    _Ix_CastReceiver(XfConditionVariable_ptr,XfConditionVariable);
    _Ix_MarshalBuffer::ArgValue _arg[2];
    _Ix_MarshalBuffer::ArgInfo* _arginfo;
    switch (_m) {
        case /* wait */ 0: {
            extern _Ix_MarshalBuffer::ArgInfo _XfConditionVariable_wait_pinfo;
            _arginfo = &_XfConditionVariable_wait_pinfo;
            XfMutex_ptr lock;
            _arg[1].u_addr = &lock;
            if (_b_receive.receive(_XfConditionVariable_wait_pinfo, _arg)) {
                lock = XfMutex::_narrow((CORBA::Object_ptr)(void*)lock);
                _this->wait(lock);
            }
            _b_reply.reply(*_arginfo, _arg);
            break;
        }
        case /* notify */ 1: {
            extern _Ix_MarshalBuffer::ArgInfo _XfConditionVariable_notify_pinfo;
            _arginfo = &_XfConditionVariable_notify_pinfo;
            _this->notify();
            _b_reply.reply(*_arginfo, _arg);
            break;
        }
        case /* broadcast */ 2: {
            extern _Ix_MarshalBuffer::ArgInfo _XfConditionVariable_broadcast_pinfo;
            _arginfo = &_XfConditionVariable_broadcast_pinfo;
            _this->broadcast();
            _b_reply.reply(*_arginfo, _arg);
            break;
        }
        default:
            _Ix_BadMethod(_m);
    }
}
//+

//+ XfSemaphore::%init,type-funcs,client,server
XfSemaphore::XfSemaphore() { }
XfSemaphore::~XfSemaphore() { }
void* XfSemaphore::_this_ptr() { return this; }
_Ix_extern__tid(XfSemaphore);
void* XfSemaphore::_narrow_tid(CORBA::TypeId t) {
    if (_Ix__tid(XfSemaphore) == t) return this;
    if (CORBA::Object::_type_id() == t) return (CORBA::Object*) this;
    return nil;
};
_Ix_ImplementField(XfSemaphore,XfSemaphore,_Ix_NullParameter)

_Ix_extern__tid(XfSemaphore);
_Ix_ExternProxy(XfSemaphore);
_Ix_ImplementGetTid(XfSemaphore,_Ix__tid(XfSemaphore))
_Ix_ImplementNarrow(XfSemaphore_ptr,XfSemaphore,_Ix_NullParameter,XfSemaphore,&_Ix_CreateProxy(XfSemaphore))
_Ix_ImplementDuplicate(XfSemaphore_ptr,XfSemaphore,_Ix_NullParameter,_Ix__tid(XfSemaphore),&_Ix_CreateProxy(XfSemaphore))
_Ix_ImplementProxy(XfSemaphore,XfSemaphore,XfSemaphore)
_Ix_MarshalBuffer::ArgDesc _XfSemaphore_wait_pdesc[2] = { 1, 4 };
_Ix_MarshalBuffer::ArgInfo _XfSemaphore_wait_pinfo = {
    _XfSemaphore_tid, 0, _XfSemaphore_wait_pdesc, 0
};
void XfSemaphore::wait() {
    _Ix_MarshalBuffer _b;
    _Ix_MarshalBuffer::ArgValue _arg[1];
    _b.invoke(this, _XfSemaphore_wait_pinfo, _arg);
}
_Ix_MarshalBuffer::ArgDesc _XfSemaphore_signal_pdesc[2] = { 1, 4 };
_Ix_MarshalBuffer::ArgInfo _XfSemaphore_signal_pinfo = {
    _XfSemaphore_tid, 1, _XfSemaphore_signal_pdesc, 0
};
void XfSemaphore::signal() {
    _Ix_MarshalBuffer _b;
    _Ix_MarshalBuffer::ArgValue _arg[1];
    _b.invoke(this, _XfSemaphore_signal_pinfo, _arg);
}
_Ix_ReceiveHdr(XfSemaphore,_Ix_NullParameter,_b_reply) {
    _Ix_CastReceiver(XfSemaphore_ptr,XfSemaphore);
    _Ix_MarshalBuffer::ArgValue _arg[1];
    _Ix_MarshalBuffer::ArgInfo* _arginfo;
    switch (_m) {
        case /* wait */ 0: {
            extern _Ix_MarshalBuffer::ArgInfo _XfSemaphore_wait_pinfo;
            _arginfo = &_XfSemaphore_wait_pinfo;
            _this->wait();
            _b_reply.reply(*_arginfo, _arg);
            break;
        }
        case /* signal */ 1: {
            extern _Ix_MarshalBuffer::ArgInfo _XfSemaphore_signal_pinfo;
            _arginfo = &_XfSemaphore_signal_pinfo;
            _this->signal();
            _b_reply.reply(*_arginfo, _arg);
            break;
        }
        default:
            _Ix_BadMethod(_m);
    }
}
//+

#if (!defined(sun) || !defined(SVR4)) && !defined(WIN32)

//
// Simple semaphore implementation for platforms except Solaris and Win32,
// which have builtin semaphores.
//

class SemaphoreImpl : public Semaphore {
public:
    SemaphoreImpl(ThreadKit_ptr, long count);
    ~SemaphoreImpl();

    OxExchange* _exchange();

    //+ XfSemaphore::*
    /* XfSemaphore */
    void wait();
    void signal();
    //+
private:
    OxLibraryExchange exchange_;
    long count_;
    Mutex_var lock_;
    ConditionVariable_var wait_;
};

SemaphoreImpl::SemaphoreImpl(ThreadKit_ptr t, long count) {
    count_ = count;
    lock_ = t->mutex_ptr();
    wait_ = t->condition();
}

SemaphoreImpl::~SemaphoreImpl() { }

OxExchange* SemaphoreImpl::_exchange() { return &exchange_; }

//+ SemaphoreImpl(XfSemaphore::wait)
void SemaphoreImpl::wait() {
    lock_->acquire();
    --count_;
    if (count_ < 0) {
	wait_->wait(lock_);
    }
    lock_->release();
}

//+ SemaphoreImpl(XfSemaphore::signal)
void SemaphoreImpl::signal() {
    lock_->acquire();
    ++count_;
    if (count_ <= 0) {
	wait_->notify();
    }
    lock_->release();
}

#endif

#define no_threads

#if defined(__sgi)

#undef no_threads

#include <signal.h>
#include <stdio.h>
#include <sys/prctl.h>
#include <sys/wait.h>
#include <ulocks.h>

extern "C" {
    extern void _exit(int);
    extern char* sys_siglist[];
    extern int unlink(const char*);
}

class ThreadImpl;
class ThreadList;

class ThreadKitImpl : public ThreadKit {
public:
    ThreadKitImpl(const char* filename);
    ~ThreadKitImpl();

    OxExchange* _exchange();

    //+ XfThreadKit::*
    /* XfThreadKit */
    XfThread_ptr thread_ptr(XfAction_ptr a);
    XfMutex_ptr mutex_ptr();
    XfConditionVariable_ptr condition();
    XfSemaphore_ptr general_semaphore(Long count);
    XfSemaphore_ptr mutex_semaphore();
    XfSemaphore_ptr wait_semaphore();
    //+

    const char* filename();
protected:
    static ThreadKitImpl* this_kit_;

#ifdef Irix4
    static void sigchild(int sig, ...);
#else
    static void sigchild(...);
#endif

    OxLibraryExchange exchange_;
    Mutex_var lock_;
    char* filename_;
    usptr_t* arena_;
    ThreadList* threads_;
    struct sigaction sigaction_;
    struct sigaction old_sigaction_;

    void report_error(long errcode);
    void terminate_all(long errcode);
};

// kludge for signal handling ...
ThreadKitImpl* ThreadKitImpl::this_kit_;

class ThreadImpl : public Thread {
public:
    ThreadImpl(ThreadKitImpl*, Action_ptr);
    ~ThreadImpl();

    OxExchange* _exchange();

    //+ XfThread::*
    /* XfThread */
    void run();
    void terminate();
    void wait(Long& status, Long& exitcode);
    //+
protected:
    OxLibraryExchange exchange_;
    const char* filename_;
    short status_;
    short exitcode_;
    pid_t id_;
    Action_var action_;

    static void sproc_entry(void*);
};

class MutexImpl : public Mutex {
public:
    MutexImpl(usptr_t* arena, ulock_t lock);
    ~MutexImpl();

    OxExchange* _exchange();

    //+ XfMutex::*
    /* XfMutex */
    void acquire();
    void release();
    Boolean try_acquire();
    //+
private:
    OxLibraryExchange exchange_;
    usptr_t* arena_;
    ulock_t lock_;
};

class ConditionImpl : public ConditionVariable {
public:
    ConditionImpl(usptr_t* arena, Mutex_ptr mutex, usema_t* wait);
    ~ConditionImpl();

    OxExchange* _exchange();

    //+ XfConditionVariable::*
    /* XfConditionVariable */
    void wait(XfMutex_ptr lock);
    void notify();
    void broadcast();
    //+
private:
    OxLibraryExchange exchange_;
    Mutex_var mutex_;
    usptr_t* arena_;
    long waiters_;
    usema_t* wait_;
};

// class ThreadKitImpl

declarePtrList(ThreadList,ThreadImpl)
implementPtrList(ThreadList,ThreadImpl)

ThreadKitImpl::ThreadKitImpl(const char* filename) {
    if (filename == nil) {
	filename_ = tempnam("/usr/tmp", "thr");
    } else {
	filename_ = new char[strlen(filename) + 1];
	strcpy(filename_, filename);
    }

    //
    // When debugging on Irix, configuring debug locks might be helpful.
    //
    // usconfig(CONF_LOCKTYPE, US_DEBUGPLUS, 0);
    //
    arena_ = usinit(filename_);
    if (arena_ == nil) {
	perror("Can't create thread kit file");
	_exit(1);
    }
    threads_ = new ThreadList(5);
    lock_ = mutex_ptr();
    sigaction_.sa_handler = &ThreadKitImpl::sigchild;
    sigemptyset(&sigaction_.sa_mask);
    sigaction_.sa_flags = 0;
    if (sigaction(SIGCLD, &sigaction_, &old_sigaction_) < 0) {
	perror("Can't catch thread exiting");
	_exit(1);
    }
    this_kit_ = this;
}

ThreadKitImpl::~ThreadKitImpl() {
    sigaction(SIGCLD, &old_sigaction_, nil);
    unlink(filename_);
    delete filename_;
    delete threads_;
}

OxExchange* ThreadKitImpl::_exchange() { return &exchange_; }

//+ ThreadKitImpl(XfThreadKit::thread_ptr)
XfThread_ptr ThreadKitImpl::thread_ptr(XfAction_ptr a) {
    lock_->acquire();
    ThreadImpl* t = new ThreadImpl(this, a);
    Thread_ptr r = Thread::_duplicate(t);
    threads_->append(t);
    lock_->release();
    return r;
}

//+ ThreadKitImpl(XfThreadKit::mutex_ptr)
XfMutex_ptr ThreadKitImpl::mutex_ptr() {
    ulock_t lock = usnewlock(arena_);
    if (lock == 0) {
	return nil;
    }
    return new MutexImpl(arena_, lock);
}

//+ ThreadKitImpl(XfThreadKit::condition)
XfConditionVariable_ptr ThreadKitImpl::condition() {
    Mutex_ptr mutex = mutex_ptr();
    if (mutex == nil) {
	return nil;
    }
    usema_t* wait = usnewsema(arena_, 0);
    if (wait == 0) {
	return nil;
    }
    return new ConditionImpl(arena_, mutex, wait);
}

//+ ThreadKitImpl(XfThreadKit::general_semaphore)
XfSemaphore_ptr ThreadKitImpl::general_semaphore(Long count) {
    return new SemaphoreImpl(this, count);
}

//+ ThreadKitImpl(XfThreadKit::mutex_semaphore)
XfSemaphore_ptr ThreadKitImpl::mutex_semaphore() {
    return new SemaphoreImpl(this, 1);
}

//+ ThreadKitImpl(XfThreadKit::wait_semaphore)
XfSemaphore_ptr ThreadKitImpl::wait_semaphore() {
    return new SemaphoreImpl(this, 0);
}

const char* ThreadKitImpl::filename() {
    return filename_;
}

//
// Handle the terminate of a child, presumably a thread.
// Alas, we need to rely on a global variable to find
// the thread kit, from which point we can report
// the error and report all other known threads.
//

#ifdef Irix4
void ThreadKitImpl::sigchild(int /* signal == SIGCLD */, ...) {
#else
void ThreadKitImpl::sigchild(...) {
#endif
    int s;
    pid_t t = wait(&s);
    if (t > 0 && !WIFSTOPPED(s)) {
	long status = WTERMSIG(s);
	if (status != 0) {
	    this_kit_->terminate_all(status);
	    _exit(1);
	}
    }
}

//
// Report an error in a thread.  Make sure to let the user
// know when the thread (possibly) generates a dump.
//

void ThreadKitImpl::report_error(long errcode) {
    if (errcode > 0 && errcode < NSIG) {
	char* msg;
	switch (errcode) {
	case SIGQUIT:
	case SIGILL:
	case SIGABRT:
	case SIGKILL:
	case SIGBUS:
	case SIGSEGV:
	    msg = " (core dumped)";
	    break;
	default:
	    msg = "";
	    break;
	}
	fprintf(stderr, "%s%s\n", sys_siglist[errcode], msg);
    }
}

//
// Report an error and terminate all threads created
// from the thread kit.
//

void ThreadKitImpl::terminate_all(long errcode) {
    report_error(errcode);
    struct sigaction sa;
    sa.sa_handler = SIG_IGN;
    sigemptyset(&sa.sa_mask);
    sa.sa_flags = 0;
    sigaction(SIGHUP, &sa, nil);
    lock_->acquire();
    for (ListItr(ThreadList) i(*threads_); i.more(); i.next()) {
	Thread_ptr t = i.cur();
	t->terminate();
	CORBA::release(t);
    }
    threads_->remove_all();
    lock_->release();
}

/* class ThreadImpl */

ThreadImpl::ThreadImpl(ThreadKitImpl* kit, Action_ptr a) {
    filename_ = kit->filename();
    id_ = 0;
    action_ = a;
}

ThreadImpl::~ThreadImpl() {
    terminate();
}

OxExchange* ThreadImpl::_exchange() { return &exchange_; }

//+ ThreadImpl(XfThread::run)
void ThreadImpl::run() {
    pid_t id = sproc(&ThreadImpl::sproc_entry, PR_SALL, (void*)this);
    if (id == -1) {
	perror("Can't run thread");
	_exit(1);
    } else if (id != 0) {
	id_ = id;
    }
}

//
// When a thread is first created, we need to call
// usinit to register the thread with the shared arena.
// Otherwise, if the first lock call tries to block
// it will fail because the thread is unknown.
//

void ThreadImpl::sproc_entry(void* thread) {
    ThreadImpl* i = (ThreadImpl*)thread;
    usinit(i->filename_);
    i->action_->execute();
}

//+ ThreadImpl(XfThread::terminate)
void ThreadImpl::terminate() {
    if (id_ != 0) {
	struct sigaction sa, save_sa;
	sa.sa_handler = SIG_IGN;
	sigemptyset(&sa.sa_mask);
	sa.sa_flags = 0;
	sigaction(SIGCLD, &sa, &save_sa);
	kill(id_, SIGTERM);
	long status, exitcode;
	wait(status, exitcode);
	id_ = 0;
	sigaction(SIGCLD, &save_sa, nil);
    }
}

//+ ThreadImpl(XfThread::wait)
void ThreadImpl::wait(Long& status, Long& exitcode) {
    int s;
    waitpid(id_, &s, 0);
    status = WTERMSIG(s);
    if (status != 0) {
	exitcode = status;
    } else {
	exitcode = WEXITSTATUS(s);
    }
}

// class MutexImpl

MutexImpl::MutexImpl(usptr_t* arena, ulock_t lock) {
    arena_ = arena;
    lock_ = lock;
}

MutexImpl::~MutexImpl() {
    usfreelock(lock_, arena_);
}

OxExchange* MutexImpl::_exchange() { return &exchange_; }

//+ MutexImpl(XfMutex::acquire)
void MutexImpl::acquire() {
    int r = ussetlock(lock_);
    if (r != 1) {
	perror("Acquire failed on lock");
	_exit(1);
    }
}

//+ MutexImpl(XfMutex::release)
void MutexImpl::release() {
    if (usunsetlock(lock_) != 0) {
	perror("Release failed on lock");
	_exit(1);
    }
}

//+ MutexImpl(XfMutex::try_acquire)
Boolean MutexImpl::try_acquire() {
    return uscsetlock(lock_, /* spins = */ 3) != 0;
}

// class ConditionImpl

ConditionImpl::ConditionImpl(
    usptr_t* arena, Mutex_ptr mutex, usema_t* wait
) {
    arena_ = arena;
    mutex_ = mutex;
    wait_ = wait;
    waiters_ = 0;
}

ConditionImpl::~ConditionImpl() {
    usfreesema(wait_, arena_);
}

OxExchange* ConditionImpl::_exchange() { return &exchange_; }

//+ ConditionImpl(XfConditionVariable::wait)
void ConditionImpl::wait(XfMutex_ptr lock) {
    mutex_->acquire();
    lock->release();
    ++waiters_;
    mutex_->release();
    uspsema(wait_);
    lock->acquire();
}

//+ ConditionImpl(XfConditionVariable::notify)
void ConditionImpl::notify() {
    mutex_->acquire();
    if (waiters_ > 0) {
	--waiters_;
	usvsema(wait_);
    }
    mutex_->release();
}

//+ ConditionImpl(XfConditionVariable::broadcast)
void ConditionImpl::broadcast() {
    mutex_->acquire();
    for (long i = 0; i < waiters_; i++) {
	usvsema(wait_);
    }
    waiters_ = 0;
    mutex_->release();
}

#endif

#ifdef __alpha

#undef no_threads

// On alpha, we assume a test on int and long is atomic.

#include <stdio.h>
#include <errno.h>
#include <pthread.h>

class ThreadImpl;
class ThreadList;
class ConditionImpl;

class ThreadKitImpl : public ThreadKit {
public:
    ThreadKitImpl(const char* filename);
    ~ThreadKitImpl();

    OxExchange* _exchange();

    //+ XfThreadKit::*
    /* XfThreadKit */
    XfThread_ptr thread_ptr(XfAction_ptr a);
    XfMutex_ptr mutex_ptr();
    XfConditionVariable_ptr condition();
    XfSemaphore_ptr general_semaphore(Long count);
    XfSemaphore_ptr mutex_semaphore();
    XfSemaphore_ptr wait_semaphore();
    //+
    void report_error(int errcode);
    void terminate_all(int errcode);
private:
    static ThreadKitImpl* this_kit_;

    OxLibraryExchange exchange_;
    Mutex_var lock_;

    ThreadList* threads_;
};

class ThreadImpl : public Thread {
public:
    ThreadImpl(ThreadKitImpl*, Mutex_ptr, Action_ptr);
    virtual ~ThreadImpl();

    OxExchange* _exchange();

    //+ XfThread::*
    /* XfThread */
    void run();
    void terminate();
    void wait(Long& status, Long& exitcode);
    //+
protected:
    OxLibraryExchange exchange_;
    Mutex_var lock_;
    ThreadKitImpl* kit_;
    Action_var action_;
    pthread_t thread_;
    enum Status { thread_created, thread_running, thread_canceled };
    Status status_;

    static void* start_routine(void*);
    static void cleanup_routine(void*);
};

class MutexImpl : public Mutex {
public:
    MutexImpl(pthread_mutex_t& mutex);
    ~MutexImpl();

    OxExchange* _exchange();

    static XfMutex_ptr create_ptr();
    //+ XfMutex::*
    /* XfMutex */
    void acquire();
    void release();
    Boolean try_acquire();
    //+
private:
    friend class ConditionImpl;

    OxLibraryExchange exchange_;
    pthread_mutex_t mutex_;
};

class ConditionImpl : public ConditionVariable {
public:
    ConditionImpl(pthread_cond_t&);
    ~ConditionImpl();

    OxExchange* _exchange();

    static XfConditionVariable_ptr create_ptr();
    //+ XfConditionVariable::*
    /* XfConditionVariable */
    void wait(XfMutex_ptr lock);
    void notify();
    void broadcast();
    //+
private:
    OxLibraryExchange exchange_;
    pthread_cond_t cond_;
};

// class ThreadKitImpl

declarePtrList(ThreadList,ThreadImpl)
implementPtrList(ThreadList,ThreadImpl)

ThreadKitImpl::ThreadKitImpl(const char* filename) {
    threads_ = new ThreadList(5);
    lock_ = MutexImpl::create_ptr();
}

ThreadKitImpl::~ThreadKitImpl() {
    delete threads_;
}

OxExchange* ThreadKitImpl::_exchange() { return &exchange_; }

//+ ThreadKitImpl(XfThreadKit::thread_ptr)
XfThread_ptr ThreadKitImpl::thread_ptr(XfAction_ptr a) {
    lock_->acquire();
    ThreadImpl* t = new ThreadImpl(this, MutexImpl::create_ptr(), a);
    Thread_ptr r = Thread::_duplicate(t);
    threads_->append(t);
    lock_->release();
    return r;
}

//+ ThreadKitImpl(XfThreadKit::mutex_ptr)
XfMutex_ptr ThreadKitImpl::mutex_ptr() {
    return MutexImpl::create_ptr();
}

//+ ThreadKitImpl(XfThreadKit::condition)
XfConditionVariable_ptr ThreadKitImpl::condition() {
    return ConditionImpl::create_ptr();
}

//+ ThreadKitImpl(XfThreadKit::general_semaphore)
XfSemaphore_ptr ThreadKitImpl::general_semaphore(Long count) {
    return new SemaphoreImpl(this, count);
}

//+ ThreadKitImpl(XfThreadKit::mutex_semaphore)
XfSemaphore_ptr ThreadKitImpl::mutex_semaphore() {
    return new SemaphoreImpl(this, 1);
}

//+ ThreadKitImpl(XfThreadKit::wait_semaphore)
XfSemaphore_ptr ThreadKitImpl::wait_semaphore() {
    return new SemaphoreImpl(this, 0);
}

void ThreadKitImpl::report_error(int errcode) {
    if (errcode > 0 && errcode < sys_nerr) {
	fprintf(stderr, "Thread error: %s\n", sys_errlist[errcode]);
    }
}

void ThreadKitImpl::terminate_all(int errcode) {
    report_error(errcode);
    lock_->acquire();
    for (ListItr(ThreadList) i(*threads_); i.more(); i.next()) {
	Thread_ptr t = i.cur();
	t->terminate();
	CORBA::release(t);
    }
    threads_->remove_all();
    lock_->release();
}

// class ThreadImpl

ThreadImpl::ThreadImpl(ThreadKitImpl* kit, Mutex_ptr lock, Action_ptr a) {
    kit_ = kit;
    lock_ = lock;
    status_ = thread_created;
    action_ = a;
}

ThreadImpl::~ThreadImpl() {
    terminate();
    CORBA::release(kit_);
}

OxExchange* ThreadImpl::_exchange() { return &exchange_; }

//+ ThreadImpl(XfThread::run)
void ThreadImpl::run() {
    lock_->acquire();
    if (status_ != thread_created) {
	return;
    }
    int status = pthread_create(
	&thread_, pthread_attr_default,
	&ThreadImpl::start_routine, (void*)this
    );
    if (status == -1) {
	perror("can't run thread");
	_exit(1);
    } else {
	status_ = thread_running;
    }
    lock_->release();
}

void* ThreadImpl::start_routine(void* thread) {
    ThreadImpl* i = (ThreadImpl*)thread;

    pthread_cleanup_push(ThreadImpl::cleanup_routine, thread);
    i->action_->execute();
    pthread_cleanup_pop(0);
    return nil;
}

void ThreadImpl::cleanup_routine(void* thread) {
    ThreadImpl* i = (ThreadImpl*)thread;
    if (i->status_ == thread_running) {
	i->kit_->terminate_all(0);
    }
}

//+ ThreadImpl(XfThread::terminate)
void ThreadImpl::terminate() {
    lock_->acquire();
    if (status_ != thread_running) {
	lock_->release();
	return;
    }
    status_ = thread_canceled;
    pthread_cancel(thread_);
    lock_->release();
    Long status, exitcode;
    wait(status, exitcode);
}

//+ ThreadImpl(XfThread::wait)
void ThreadImpl::wait(Long& status, Long& exitcode) {
    if (status_ == thread_created) {
	status = 0;
	exitcode = 0;
    } else {
	void* exit_status;
	status = pthread_join(thread_, &exit_status);
	lock_->acquire();
	if (status_ != thread_created) {
	    pthread_detach(&thread_);
	    status_ = thread_created;
	}
	lock_->release();

	if (status != 0) {
	    exitcode = status;
	} else {
	    exitcode = (long)exit_status;
	}
    }
}

// class MutexImpl

MutexImpl::MutexImpl(pthread_mutex_t& mutex) : mutex_(mutex) { }

MutexImpl::~MutexImpl() {
    pthread_mutex_destroy(&mutex_);
}

OxExchange* MutexImpl::_exchange() { return &exchange_; }

XfMutex_ptr MutexImpl::create_ptr() {
    pthread_mutex_t mutex;

    int status = pthread_mutex_init(&mutex, pthread_mutexattr_default);
    if (status == -1) {
	return nil;
    }
    return new MutexImpl(mutex);
}

//+ MutexImpl(XfMutex::acquire)
void MutexImpl::acquire() {
    pthread_mutex_lock(&mutex_);
}

//+ MutexImpl(XfMutex::release)
void MutexImpl::release() {
    pthread_mutex_unlock(&mutex_);
}

//+ MutexImpl(XfMutex::try_acquire)
Boolean MutexImpl::try_acquire() {
    return pthread_mutex_trylock(&mutex_) == 1;
}

// class ConditionImpl

ConditionImpl::ConditionImpl(pthread_cond_t& cond) : cond_(cond) { }

ConditionImpl::~ConditionImpl() {
    pthread_cond_destroy(&cond_);
}

OxExchange* ConditionImpl::_exchange() { return &exchange_; }

XfConditionVariable_ptr ConditionImpl::create_ptr() {
    pthread_cond_t cond;

    int status = pthread_cond_init(&cond, pthread_condattr_default);
    if (status == -1) {
	return nil;
    }

    return new ConditionImpl(cond);
}

//+ ConditionImpl(XfConditionVariable::wait)
void ConditionImpl::wait(XfMutex_ptr lock) {
    MutexImpl* i = (MutexImpl*)lock;
    pthread_cond_wait(&cond_, &i->mutex_);
}

//+ ConditionImpl(XfConditionVariable::notify)
void ConditionImpl::notify() {
    pthread_cond_signal(&cond_);
}

//+ ConditionImpl(XfConditionVariable::broadcast)
void ConditionImpl::broadcast() {
    pthread_cond_broadcast(&cond_);
}

#endif

#if defined(sun) && defined(SVR4)

#undef no_threads
#include <errno.h>
#include <signal.h>
#include <stdio.h>
#include <thread.h>
#include <unistd.h>

class ThreadKitImpl : public ThreadKit {
public:
    ThreadKitImpl(const char*);
    virtual ~ThreadKitImpl();

    OxExchange* _exchange();

    //+ XfThreadKit::*
    /* XfThreadKit */
    XfThread_ptr thread_ptr(XfAction_ptr a);
    XfMutex_ptr mutex_ptr();
    XfConditionVariable_ptr condition();
    XfSemaphore_ptr general_semaphore(Long count);
    XfSemaphore_ptr mutex_semaphore();
    XfSemaphore_ptr wait_semaphore();
    //+
private:
    OxLibraryExchange exchange_;
};

class ThreadImpl : public Thread {
public:
    ThreadImpl(Action_ptr);
    virtual ~ThreadImpl();

    OxExchange* _exchange();

    //+ XfThread::*
    /* XfThread */
    void run();
    void terminate();
    void wait(Long& status, Long& exitcode);
    //+

protected:
    OxLibraryExchange exchange_;
    thread_t thread_;
    Action_var action_;
    struct sigaction saved_sigaction_;

    static void* sproc_entry(void*);
    static void thread_sigterm_handler();
};

class MutexImpl : public Mutex {
public:
    MutexImpl();
    virtual ~MutexImpl();

    OxExchange* _exchange();

    //+ XfMutex::*
    /* XfMutex */
    void acquire();
    void release();
    Boolean try_acquire();
    //+

    mutex_t* lock();
private:
    OxLibraryExchange exchange_;
    mutex_t lock_;
};

class ConditionImpl : public ConditionVariable {
public:
    ConditionImpl();
    virtual ~ConditionImpl();

    OxExchange* _exchange();

    //+ XfConditionVariable::*
    /* XfConditionVariable */
    void wait(XfMutex_ptr lock);
    void notify();
    void broadcast();
    //+
private:
    OxLibraryExchange exchange_;
    cond_t wait_;
};

class SemaphoreImpl : public Semaphore {
public:
    SemaphoreImpl(unsigned int);
    virtual ~SemaphoreImpl();

    OxExchange* _exchange();

    //+ XfSemaphore::*
    /* XfSemaphore */
    void wait();
    void signal();
    //+
private:
    OxLibraryExchange exchange_;
    sema_t semaphore_;
};

// class ThreadKitImpl

ThreadKitImpl::ThreadKitImpl(const char*) { }

ThreadKitImpl::~ThreadKitImpl() { }

OxExchange* ThreadKitImpl::_exchange() { return &exchange_; }

//+ ThreadKitImpl(XfThreadKit::thread_ptr)
XfThread_ptr ThreadKitImpl::thread_ptr(XfAction_ptr a) {
    return new ThreadImpl(a);
}

//+ ThreadKitImpl(XfThreadKit::mutex_ptr)
XfMutex_ptr ThreadKitImpl::mutex_ptr() {
    return new MutexImpl();
}

//+ ThreadKitImpl(XfThreadKit::condition)
XfConditionVariable_ptr ThreadKitImpl::condition() {
    return new ConditionImpl();
}

//+ ThreadKitImpl(XfThreadKit::general_semaphore)
XfSemaphore_ptr ThreadKitImpl::general_semaphore(Long count) {
    return new SemaphoreImpl((unsigned int)count);
}

//+ ThreadKitImpl(XfThreadKit::mutex_semaphore)
XfSemaphore_ptr ThreadKitImpl::mutex_semaphore() {
    return general_semaphore(1);
}

//+ ThreadKitImpl(XfThreadKit::wait_semaphore)
XfSemaphore_ptr ThreadKitImpl::wait_semaphore() {
    return general_semaphore(0);
}

// class ThreadImpl

//
// Key to access thread-specific data, i.e. a pointer to the
// associated C++ thread object.
//
thread_key_t solaris_current_thread;

struct ThreadData
{
  Boolean terminating_;
};

static int startup() {
    thr_keycreate(&solaris_current_thread, nil);
    return 0;
}

static int dummy = startup();

//
// SIGTERM handler for each thread... we stashed a pointer to the
// thread object associated with this thread, and the terminating
// member variable will be set if the thread was cleanly requested to
// terminate.
//

void ThreadImpl::thread_sigterm_handler() {
    ThreadData* thr;
    thr_getspecific(solaris_current_thread, (void**) &thr);
    if (thr->terminating_) {
        delete thr;
	thr_exit(0);
    } else {
	exit(666);
    }
}

ThreadImpl::ThreadImpl(Action_ptr a) {
    thread_ = 0;
    action_ = a;
}

ThreadImpl::~ThreadImpl() {
    terminate();
}

OxExchange* ThreadImpl::_exchange() { return &exchange_; }

//+ ThreadImpl(XfThread::run)
void ThreadImpl::run() {
    int status = thr_create(
        NULL, 0, &ThreadImpl::sproc_entry, this, 0, &thread_
    );
    if (status != 0) {
	perror("can't run thread");
	_exit(1);
    }
}

void* ThreadImpl::sproc_entry(void* thread) {
    ThreadImpl* i = (ThreadImpl*)thread;
    sigset_t signals;

    // Register pointer to thread-specific data.
    ThreadData* data = new ThreadData;
    data->terminating_ = false;
    thr_setspecific(solaris_current_thread, data);

    // Set SIGTERM handler for this thread.
    sigemptyset(&signals);
    sigaddset(&signals, SIGTERM);
    thr_sigsetmask(SIG_SETMASK, &signals, nil);
    struct sigaction sa;
    sa.sa_handler = thread_sigterm_handler;
    sa.sa_flags = 0;
    sigaction(SIGTERM, &sa, &i->saved_sigaction_);

    i->action_->execute();
    return nil;
}

//+ ThreadImpl(XfThread::terminate)
void ThreadImpl::terminate() {
    if (thread_ != 0) {
        ThreadData* data;
        thr_getspecific(solaris_current_thread, (void**) &data);
	if (data)
	  data->terminating_ = true;
	thr_kill(thread_, SIGTERM);
	thread_ = 0;
    }
}

//+ ThreadImpl(XfThread::wait)
void ThreadImpl::wait(Long& status, Long& exitcode) {
    if (thread_ == nil) {
	status = 0;
	exitcode = 0;
    } else {
	void* exit_status;
	status = thr_join(thread_, NULL, &exit_status);
	if (status != 0) {
	    exitcode = status;
	} else {
	    exitcode = (long)exit_status;
	}
    }
}

// class MutexImpl

MutexImpl::MutexImpl() {
    int status = mutex_init(&lock_, USYNC_THREAD, NULL);
    if (status != 0) {
    	perror("failed to initialize mutex lock");
	_exit(1);
    }
}

MutexImpl::~MutexImpl() {
    int status = mutex_destroy(&lock_);
    if (status != 0) {
    	perror("failed to destroy lock");
    	_exit(1);
    }
}

OxExchange* MutexImpl::_exchange() { return &exchange_; }

//+ MutexImpl(XfMutex::acquire)
void MutexImpl::acquire() {
    int status = mutex_lock(&lock_);
    if (status != 0) {
    	perror("failed to lock");
    	_exit(1);
    }
}

//+ MutexImpl(XfMutex::release)
void MutexImpl::release() {
    int status = mutex_unlock(&lock_);
    if (status != 0) {
    	perror("failed to unlock");
    	_exit(1);
    }
}

//+ MutexImpl(XfMutex::try_acquire)
Boolean MutexImpl::try_acquire() {
    return mutex_trylock(&lock_) == 0;
}

mutex_t* MutexImpl::lock() {
    return &lock_;
}
    
// class ConditionImpl

ConditionImpl::ConditionImpl() {
    int status = cond_init(&wait_, USYNC_THREAD, NULL);
    if (status != 0) {
    	perror("failed to initialize condition");
	_exit(1);
    }
}

ConditionImpl::~ConditionImpl() {
    int status = cond_destroy(&wait_);
    if (status != 0) {
    	perror("failed to destroy condition");
    	_exit(1);
    }
}

OxExchange* ConditionImpl::_exchange() { return &exchange_; }

//+ ConditionImpl(XfConditionVariable::wait)
void ConditionImpl::wait(XfMutex_ptr lock) {
    cond_wait(&wait_, ((MutexImpl*)lock)->lock());
}

//+ ConditionImpl(XfConditionVariable::notify)
void ConditionImpl::notify() {
    int status = cond_signal(&wait_);
    if (status != 0) {
	perror("failed in condition signal");
	_exit(1);
    }
}

//+ ConditionImpl(XfConditionVariable::broadcast)
void ConditionImpl::broadcast() {
    int status = cond_broadcast(&wait_);
    if (status != 0) {
    	perror("failed in condition broadcast");
    	_exit(1);
    }
}

// class SemaphoreImpl

SemaphoreImpl::SemaphoreImpl(unsigned int count) {
    int status = sema_init(&semaphore_, count, USYNC_THREAD, NULL);
    if (status != 0) {
	perror("failed to inialize semaphore");
	_exit(1);
    }
}

SemaphoreImpl::~SemaphoreImpl() {
    int status = sema_destroy(&semaphore_);
    if (status != 0) {
	perror("failed to destroy semaphore");
	_exit(1);
    }
}

OxExchange* SemaphoreImpl::_exchange() { return &exchange_; }

//+ SemaphoreImpl(XfSemaphore::wait)
void SemaphoreImpl::wait() {
    int status = sema_wait(&semaphore_);
    if (status != 0) {
	perror("failed to wait on semaphore");
	_exit(1);
    }
}

//+ SemaphoreImpl(XfSemaphore::signal)
void SemaphoreImpl::signal() {
    int status = sema_post(&semaphore_);
    if (status != 0) {
	perror("failed to post on semaphore");
	_exit(1);
    }
}

#endif

#ifdef WIN32

#undef no_threads
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

class ThreadKitImpl : public ThreadKit {
public:
    ThreadKitImpl(const char*);
    virtual ~ThreadKitImpl();
    OxExchange* _exchange();

    //+ XfThreadKit::*
    /* XfThreadKit */
    XfThread_ptr thread_ptr(XfAction_ptr a);
    XfMutex_ptr mutex_ptr();
    XfConditionVariable_ptr condition();
    XfSemaphore_ptr general_semaphore(Long count);
    XfSemaphore_ptr mutex_semaphore();
    XfSemaphore_ptr wait_semaphore();
    //+
private:
    OxLibraryExchange exchange_;
};

class ThreadImpl : public Thread {
public:
    ThreadImpl(Action_ptr);
    virtual ~ThreadImpl();
    OxExchange* _exchange();

    //+ XfThread::*
    /* XfThread */
    void run();
    void terminate();
    void wait(Long& status, Long& exitcode);
    //+
protected:
    OxLibraryExchange exchange_;
    HANDLE thread_;
    DWORD thread_id_;
    Action_var action_;

    static DWORD APIENTRY sproc_entry(void*);
};

class LockImpl : public Mutex {
public:
    LockImpl();
    virtual ~LockImpl();
    OxExchange* _exchange();

    //+ XfMutex::*
    /* XfMutex */
    void acquire();
    void release();
    Boolean try_acquire();
    //+
private:
    OxLibraryExchange exchange_;
    HANDLE lock_;
};

declareList(EventList,HANDLE)
implementList(EventList,HANDLE)

class ConditionImpl : public ConditionVariable {
public:
    ConditionImpl(Mutex_ptr);
    virtual ~ConditionImpl();
    OxExchange* _exchange();

    //+ XfConditionVariable::*
    /* XfConditionVariable */
    void wait(XfMutex_ptr lock);
    void notify();
    void broadcast();
    //+
private:
    OxLibraryExchange exchange_;
    EventList waiters_;
    Mutex_var mutex_;
};

class SemaphoreImpl : public Semaphore {
public:
    SemaphoreImpl(unsigned int);
    virtual ~SemaphoreImpl();
    OxExchange* _exchange();

    //+ XfSemaphore::*
    /* XfSemaphore */
    void wait();
    void signal();
    //+
private:
    OxLibraryExchange exchange_;
    HANDLE semaphore_;
};

// class ThreadKitImpl

ThreadKitImpl::ThreadKitImpl(const char*) { }
ThreadKitImpl::~ThreadKitImpl() { }

OxExchange* ThreadKitImpl::_exchange() { return &exchange_; }

//+ ThreadKitImpl(XfThreadKit::thread_ptr)
XfThread_ptr ThreadKitImpl::thread_ptr(XfAction_ptr a) {
    return new ThreadImpl(a);
}

//+ ThreadKitImpl(XfThreadKit::mutex_ptr)
XfMutex_ptr ThreadKitImpl::mutex_ptr() {
    return new LockImpl();
}

//+ ThreadKitImpl(XfThreadKit::condition)
XfConditionVariable_ptr ThreadKitImpl::condition() {
    return new ConditionImpl(mutex_ptr());
}

//+ ThreadKitImpl(XfThreadKit::general_semaphore)
XfSemaphore_ptr ThreadKitImpl::general_semaphore(Long count) {
    return new SemaphoreImpl((unsigned int)count);
}

//+ ThreadKitImpl(XfThreadKit::mutex_semaphore)
XfSemaphore_ptr ThreadKitImpl::mutex_semaphore() {
    return general_semaphore(1);
}

//+ ThreadKitImpl(XfThreadKit::wait_semaphore)
XfSemaphore_ptr ThreadKitImpl::wait_semaphore() {
    return general_semaphore(0);
}

// class ThreadImpl

ThreadImpl::ThreadImpl(Action_ptr a) {
    thread_ = 0;
    thread_id_ = 0;
    action_ = Action::_duplicate(a);
}

ThreadImpl::~ThreadImpl() {
    terminate();
}

OxExchange* ThreadImpl::_exchange() { return &exchange_; }

//+ ThreadImpl(XfThread::run)
void ThreadImpl::run() {
    thread_ = CreateThread(
	NULL, 0, &ThreadImpl::sproc_entry, this, 0, &thread_id_
    );
    if (thread_ == 0) {
	fprintf(stderr, "can't run thread\n");
	exit(1);
    }
}

DWORD APIENTRY ThreadImpl::sproc_entry(void* thread) {
    ThreadImpl* i = (ThreadImpl*)thread;
    i->action_->execute();
    return nil;
}

//+ ThreadImpl(XfThread::terminate)
void ThreadImpl::terminate() {
    if (thread_ != 0) {
	TerminateThread(thread_, 0);
	thread_ = 0;
    }
}

//+ ThreadImpl(XfThread::wait)
void ThreadImpl::wait(Long& status, Long& exitcode) {
    if (thread_ == nil) {
	status = 0;
	exitcode = 0;
    } else {
	WaitForSingleObject(thread_, INFINITE);
	DWORD exit_code;
	if (GetExitCodeThread(thread_, &exit_code)) {
	    exitcode = exit_code;
	} else {
	    exitcode = 0;
	}
	status = 0;
    }
}

// class LockImpl

LockImpl::LockImpl() {
    lock_ = CreateMutex(NULL, FALSE, NULL);
    if (lock_ == NULL) {
	fprintf(stderr,"failed to initialize mutex lock\n");
	exit(1);
    }
}

LockImpl::~LockImpl() {
    if (!CloseHandle(lock_)) {
	fprintf(stderr,"failed to destroy lock\n");
	exit(1);
    }
}

OxExchange* LockImpl::_exchange() { return &exchange_; }

//+ LockImpl(XfMutex::acquire)
void LockImpl::acquire() {
    DWORD status = WaitForSingleObject(lock_, INFINITE);
    //
    // The only error status that we should be able to see in this
    // invocation is WAIT_ABANDONED and we can probably reasonably
    // proceed under these circumstances anyway... but it's not
    // guaranteed to be the case.  We have no interface to do otherwise.
    //
    if (status && status != WAIT_ABANDONED) {
	fprintf(stderr,"failed to lock\n");
	exit(1);
    }
}

//+ LockImpl(XfMutex::release)
void LockImpl::release() {
    if (!ReleaseMutex(lock_)) {
	fprintf(stderr,"failed to unlock\n");
	exit(1);
    }
}

//+ LockImpl(XfMutex::try_acquire)
Boolean LockImpl::try_acquire() {
    DWORD status = WaitForSingleObject(lock_, 0);
    if (status == WAIT_TIMEOUT) {
	return false;
    } else if (status == WAIT_FAILED) {
	fprintf(stderr,"failed to lock\n");
	exit(1);
    }
    return true;
}

// class ConditionImpl

ConditionImpl::ConditionImpl(Mutex_ptr l) {
    mutex_ = l;
}

ConditionImpl::~ConditionImpl() {
    long nevents = waiters_.count();
    for (long i = 0; i < nevents; i++) {
	if (!CloseHandle(waiters_.item(i))) {
	    fprintf(stderr,"failed to destroy condition\n");
	    exit(1);
	}
    }
}

OxExchange* ConditionImpl::_exchange() { return &exchange_; }

//+ ConditionImpl(XfConditionVariable::wait)
void ConditionImpl::wait(XfMutex_ptr lock) {
    mutex_->acquire();
    lock->release();
    HANDLE h = CreateEvent(NULL, TRUE, FALSE, NULL);
    if (h == NULL) {
	fprintf(stderr,"can't create synchronization event\n");
	exit(1);
    }
    waiters_.append(h);
    mutex_->release();
    WaitForSingleObject(h, INFINITE);
    CloseHandle(h);
    lock->acquire();
}

//+ ConditionImpl(XfConditionVariable::notify)
void ConditionImpl::notify() {
    mutex_->acquire();
    long nevents = waiters_.count();
    if (nevents > 0) {
	HANDLE h = waiters_.item(0);
	waiters_.remove(0);
	if (!SetEvent(h)) {
	    fprintf(stderr,"failed to signal thread\n");
	    exit(1);
	}
    }
    mutex_->release();
}

//+ ConditionImpl(XfConditionVariable::broadcast)
void ConditionImpl::broadcast() {
    mutex_->acquire();
    long nevents = waiters_.count();
    for (long i = 0; i < nevents; i++) {
	HANDLE h = waiters_.item(i);
	if (!SetEvent(h)) {
	    fprintf(stderr,"failed to signal thread\n");
	    exit(1);
	}
	CloseHandle(h);
    }
    waiters_.remove_all();
    mutex_->release();
}

// class SemaphoreImpl

SemaphoreImpl::SemaphoreImpl(unsigned int count) {
    semaphore_ = CreateSemaphore(NULL, count, count, NULL);
    if (semaphore_ == 0) {
	fprintf(stderr,"failed to inialize semaphore\n");
	exit(1);
    }
}

SemaphoreImpl::~SemaphoreImpl() {
    if (!CloseHandle(semaphore_)) {
	fprintf(stderr,"failed to destroy semaphore\n");
	exit(1);
    }
}

OxExchange* SemaphoreImpl::_exchange() { return &exchange_; }

//+ SemaphoreImpl(XfSemaphore::wait)
void SemaphoreImpl::wait() {
    if (WaitForSingleObject(semaphore_, INFINITE) == WAIT_FAILED) {
	fprintf(stderr,"failed to wait on semaphore\n");
	exit(1);
    }
}

//+ SemaphoreImpl(XfSemaphore::signal)
void SemaphoreImpl::signal() {
    if (!ReleaseSemaphore(semaphore_, 1, NULL)) {
	fprintf(stderr,"failed to post on semaphore\n");
	exit(1);
    }
}

#endif

#ifdef no_threads

//
// ThreadKit implementation for system with no threads.
// We don't create threads (return nil), but we do create
// dummy locks and condition variables that never block.
//

class ThreadKitImpl : public ThreadKit {
public:
    ThreadKitImpl(const char*);
    ~ThreadKitImpl();

    OxExchange* _exchange();

    //+ XfThreadKit::*
    /* XfThreadKit */
    XfThread_ptr thread_ptr(XfAction_ptr a);
    XfMutex_ptr mutex_ptr();
    XfConditionVariable_ptr condition();
    XfSemaphore_ptr general_semaphore(Long count);
    XfSemaphore_ptr mutex_semaphore();
    XfSemaphore_ptr wait_semaphore();
    //+
protected:
    OxLibraryExchange exchange_;
};

class MutexImpl : public Mutex {
public:
    MutexImpl();
    ~MutexImpl();

    OxExchange* _exchange();

    //+ XfMutex::*
    /* XfMutex */
    void acquire();
    void release();
    Boolean try_acquire();
    //+
protected:
    OxLibraryExchange exchange_;
};

class ConditionImpl : public ConditionVariable {
public:
    ConditionImpl();
    ~ConditionImpl();

    OxExchange* _exchange();

    //+ XfConditionVariable::*
    /* XfConditionVariable */
    void wait(XfMutex_ptr lock);
    void notify();
    void broadcast();
    //+
protected:
    OxLibraryExchange exchange_;
};

// class ThreadKitImpl

ThreadKitImpl::ThreadKitImpl(const char*) { }
ThreadKitImpl::~ThreadKitImpl() { }

OxExchange* ThreadKitImpl::_exchange() { return &exchange_; }

//+ ThreadKitImpl(XfThreadKit::thread_ptr)
XfThread_ptr ThreadKitImpl::thread_ptr(XfAction_ptr a) {
    return nil;
}

//+ ThreadKitImpl(XfThreadKit::mutex_ptr)
XfMutex_ptr ThreadKitImpl::mutex_ptr() {
    return new MutexImpl;
}

//+ ThreadKitImpl(XfThreadKit::condition)
XfConditionVariable_ptr ThreadKitImpl::condition() {
    return new ConditionImpl;
}

//+ ThreadKitImpl(XfThreadKit::general_semaphore)
XfSemaphore_ptr ThreadKitImpl::general_semaphore(Long count) {
    return new SemaphoreImpl(this, count);
}

//+ ThreadKitImpl(XfThreadKit::mutex_semaphore)
XfSemaphore_ptr ThreadKitImpl::mutex_semaphore() {
    return new SemaphoreImpl(this, 1);
}

//+ ThreadKitImpl(XfThreadKit::wait_semaphore)
XfSemaphore_ptr ThreadKitImpl::wait_semaphore() {
    return new SemaphoreImpl(this, 0);
}

// class MutexImpl

MutexImpl::MutexImpl() { }
MutexImpl::~MutexImpl() { }

OxExchange* MutexImpl::_exchange() { return &exchange_; }

//+ MutexImpl(XfMutex::acquire)
void MutexImpl::acquire() { }

//+ MutexImpl(XfMutex::release)
void MutexImpl::release() { }

//+ MutexImpl(XfMutex::try_acquire)
Boolean MutexImpl::try_acquire() {
    return true;
}

// class ConditionImpl

ConditionImpl::ConditionImpl() { }
ConditionImpl::~ConditionImpl() { }

OxExchange* ConditionImpl::_exchange() { return &exchange_; }

//+ ConditionImpl(XfConditionVariable::wait)
void ConditionImpl::wait(XfMutex_ptr) { }

//+ ConditionImpl(XfConditionVariable::notify)
void ConditionImpl::notify() { }

//+ ConditionImpl(XfConditionVariable::broadcast)
void ConditionImpl::broadcast() { }

#endif

// class ThreadLib

ThreadKit_ptr ThreadLib::kit_;

ThreadKit_ptr ThreadLib::thread_kit_ptr() {
    if (is_nil(kit_)) {
	kit_ = new ThreadKitImpl(nil);
    }
    return kit_;
}

void ThreadLib::thread_kit_ptr(ThreadKit_ptr t) {
    kit_ = t;
}

//
// The helper class gives us control at program exit so that we can
// release the thread kit.
//

class ThreadLibHelper {
public:
    ThreadLibHelper() { }
    ~ThreadLibHelper();
};

static ThreadLibHelper helper;

ThreadLibHelper::~ThreadLibHelper() {
    CORBA::release(ThreadLib::thread_kit_ptr());
    ThreadLib::thread_kit_ptr(nil);
}
