//
// $XConsortium$
//

//
// Copyright (c) 1992-94 Silicon Graphics, Inc.
//
// Permission to use, copy, modify, distribute, and sell this software and 
// its documentation for any purpose is hereby granted without fee,
// provided that (i) the above copyright notices and this permission notice
// appear in all copies of the software and related documentation, and
// (ii) the name of Silicon Graphics may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Silicon Graphics.
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
//
// IN NO EVENT SHALL SILICON GRAPHICS BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
//

#ifndef Fresco_defs_impl_threads_h
#define Fresco_defs_impl_threads_h

//
// Library access to thread services.
//

#include <Fresco/defs_impl/thread.h>

//- ThreadLib*
class export ThreadLib {
    //. ThreadLib is a library interface to access thread system services.
public:

    //- thread_kit_ptr
    static ThreadKit_ptr thread_kit_ptr();
    static void thread_kit_ptr(ThreadKit_ptr);
	//. Set or get the current thread kit that is used to access
	//. thread system services.  These operations assume that
	//. the kit resides in the current address space, and as such
	//. does no memory management.  The caller therefore should not
	//. release the returned kit object reference.
protected:
    static ThreadKit_ptr kit_;
};

#endif
