/*
 * Copyright (c) 1995 Silicon Graphics, Inc.
 * Copyright (c) 1995 Fujitsu, Ltd.
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * Silicon Graphics and Fujitsu may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Silicon Graphics and Fujitsu.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 *
 * IN NO EVENT SHALL SILICON GRAPHICS OR FUJITSU BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#include "stdafx.h"
#include "CFresco.h"


CFrescoWindow::CFrescoWindow(
    Win32Display* d, Win32Screen* s, Viewer_ptr v
) : Win32Window(d, s, v) {
}

CFrescoWindow::~CFrescoWindow() {
}

LRESULT CFrescoWindow::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) {
    Win32Window::window_proc(message, wParam, lParam);

    return CWnd::WindowProc(message, wParam, lParam);
}

void CFrescoWindow::OnGetMinMaxInfo(MINMAXINFO* lpMMI) {
    on_get_min_max_info(lpMMI);
}

void CFrescoWindow::OnPaint() {
    on_paint();
}

void CFrescoWindow::OnSize(UINT type, int cx, int cy) {
    on_size(type, cx, cy);
}

void CFrescoWindow::OnMove(int x, int y) {
    on_move(x, y);
}

void CFrescoWindow::OnPaletteChanged(CWnd* pFocusWnd) {
    on_palette_changed(pFocusWnd->m_hWnd);
}

BOOL CFrescoWindow::OnQueryNewPalette() {
    return on_query_new_palette();
}

BOOL CFrescoWindow::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) {
    return on_set_cursor(pWnd->m_hWnd, nHitTest, message);
    // CWnd::OnSetCursor(pWnd, nHitTest, message);
}

BEGIN_MESSAGE_MAP(CFrescoWindow,CWnd)
    ON_WM_PAINT()
    ON_WM_SIZE()
    ON_WM_MOVE()
    ON_WM_PALETTECHANGED()
    ON_WM_QUERYNEWPALETTE()
    ON_WM_SETCURSOR()
END_MESSAGE_MAP()

HWND CFrescoWindow::wnd() {
    return m_hWnd;
}

void CFrescoWindow::create_window() {
}
