/*
 * Copyright (c) 1995 Silicon Graphics, Inc.
 * Copyright (c) 1995 Fujitsu, Ltd.
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * Silicon Graphics and Fujitsu may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Silicon Graphics and Fujitsu.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 *
 * IN NO EVENT SHALL SILICON GRAPHICS OR FUJITSU BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef Fresco_Impls_CFrescoWindow_h
#define Fresco_Impls_CFrescoWindow_h

#include "stdafx.h"

#include <Fresco/defs_Win32/Wwindow.h>

class export CFrescoWindow : public CWnd, public Win32Window {
public:
    CFrescoWindow(Win32Display*, Win32Screen*, Viewer_ptr);
    ~CFrescoWindow();

    // CWnd overrides
    LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);

    // CWnd message handlers
    void OnGetMinMaxInfo(MINMAXINFO* lpMMI);
    void OnPaint();
    void OnSize(UINT type, int cx, int cy);
    void OnMove(int x, int y);
    void OnPaletteChanged(CWnd* pFocusWnd);
    BOOL OnQueryNewPalette();
    BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
    
    DECLARE_MESSAGE_MAP()

protected:
    HWND wnd();
    void create_window();
};

#endif
