// bridge.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "bridge.h"

#include "mainfrm.h"
#include "bridgdoc.h"
#include "bridgvw.h"

#include <Fresco/defs/fcontext.h>
#include <Fresco/defs/fresco.h>
#include <Fresco/figures/figures.h>
#include <Fresco/widgets/widgets.h>

#include <Fresco/defs_Win32/Wdisplay.h>
#include <Fresco/defs_Win32/Wscreen.h>

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBridgeApp

BEGIN_MESSAGE_MAP(CBridgeApp, CWinApp)
	//{{AFX_MSG_MAP(CBridgeApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBridgeApp construction

CBridgeApp::CBridgeApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CBridgeApp object

CBridgeApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CBridgeApp initialization

BOOL CBridgeApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

	Enable3dControls();

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CBridgeDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CBridgeView));
	AddDocTemplate(pDocTemplate);

        static int argc = 1;
        static char* argv[] = {"Bridge", nil};
        fresco_context_ = FrescoLib::init_default_context(
	    "Bridge", argc, argv
        );
        display_ = Win32Display::_narrow(fresco_context_->display_ptr());
        screen_ = Win32Screen::_narrow(display_->default_screen());
        figure_kit_ = Fresco_resolve_object(FigureKit, "figures_impl");
        figure_style_ = figure_kit_->default_style();
        widget_kit_ = Fresco_resolve_object(WidgetKit, "widgets_impl");
	class_name_ = AfxRegisterWndClass(0);

	// create a new (empty) document
	OnFileNew();

	if (m_lpCmdLine[0] != '\0')
	{
		// TODO: add command line processing here
	}

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CBridgeApp commands

BOOL CBridgeApp::OnIdle(LONG lCount) 
{
	display_->repair();
	
	return CWinApp::OnIdle(lCount);
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CBridgeApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}
