// bridgvw.cpp : implementation of the CBridgeView class
//

#include "stdafx.h"
#include "bridge.h"

#include "bridgdoc.h"
#include "bridgvw.h"

#include <Fresco/defs/fresco.h>
#include <Fresco/figures/figures.h>
#include <Fresco/widgets/widgets.h>
#include "CFresco.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBridgeView

IMPLEMENT_DYNCREATE(CBridgeView, CView)

BEGIN_MESSAGE_MAP(CBridgeView, CView)
	//{{AFX_MSG_MAP(CBridgeView)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBridgeView construction/destruction

CBridgeView::CBridgeView()
{
}

CBridgeView::~CBridgeView()
{
}

/////////////////////////////////////////////////////////////////////////////
// CBridgeView drawing

void CBridgeView::OnDraw(CDC* pDC)
{
	CBridgeDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDC->Rectangle(0, 0, 100, 100);
}

/////////////////////////////////////////////////////////////////////////////
// CBridgeView message handlers

int CBridgeView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	CharString_var hello = FrescoLib::string_ref("hello");
	Glyph_var label = theApp.figure_kit_->label(theApp.figure_style_, hello);
	Button_var button = theApp.widget_kit_->push_button(label, nil);

	CFrescoWindow* fresco_window = new CFrescoWindow(
		theApp.display_, theApp.screen_, button
	);
	fresco_window->CreateEx(
		0, theApp.class_name_, "Fresco Bridge", WS_CHILD,
		10, 10, 100, 100,
		m_hWnd, NULL, NULL
	);
	fresco_window->ShowWindow(SW_SHOW);

	
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CBridgeView diagnostics

#ifdef _DEBUG
void CBridgeView::AssertValid() const
{
	CView::AssertValid();
}

void CBridgeView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CBridgeDoc* CBridgeView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBridgeDoc)));
	return (CBridgeDoc*)m_pDocument;
}
#endif //_DEBUG
