/*
 * button.cxx
 */

#include <Fresco/defs/fresco.h>
#include <Fresco/figures/figures.h>
#include <Fresco/layouts/layouts.h>
#include <Fresco/widgets/widgets.h>
#include <Fresco/defs_impl/action.h>
#include <stdio.h>

class App {
public:
    void push_me() { printf("pushed\n"); }
};

declareActionCallback(App)
implementActionCallback(App)

int main(int argc, char** argv) {
    App a;
    FrescoContext* fc = FrescoLib::init_default_context(
	"FTutorial", argc, argv
    );
    FigureKit_var figures = Fresco_resolve_object(FigureKit, "figures_impl");
    WidgetKit_var widgets = Fresco_resolve_object(WidgetKit, "widgets_impl");
    LayoutKit_var layouts = Fresco_resolve_object(LayoutKit, "layouts_impl");

    FigureStyle_var figstyle = figures->default_style();
    CharString_var string = FrescoLib::string_ref("Push");
    
    Button_var button = widgets->push_button(
	Glyph_var(figures->label(figstyle, string)),
	Action_var(new ActionCallback(App)(&a, &App::push_me))
    );
    FrescoLib::run(button, Glyph_var(layouts->margin(button, Coord(15))));
    CORBA::release(fc);
    return 0;
}

