/*
 * floatview.cxx
 */

#include <Fresco/defs/fresco.h>
#include <stdio.h>
#include "ftutorial.h"   
#include "floatview.h"

declareActionCallback(FloatView);
implementActionCallback(FloatView);

FloatView::FloatView(FieldSubject_ptr fsubj, Adjustment_ptr adj) {
    fsubj_ = FieldSubject::_duplicate(fsubj);
    adj_ = Adjustment::_duplicate(adj);
    str_callback_ = new ProxyObserver(
	fsubj_,	new ActionCallback(FloatView)(this, &FloatView::string_update)
    );
    adj_callback_ = new ProxyObserver(
	adj_, new ActionCallback(FloatView)(this, &FloatView::adjustment_update)
    );
    adjustment_update();
}

FloatView::~FloatView() { }

void FloatView::string_update() {
    char* str = fsubj_->get_all();
    float val;
    if (sscanf(str, "%f", &val)) {
	adj_->scroll_to(val);  // change subject
    }
    delete str;
}

void FloatView::adjustment_update() {
    Adjustment::Settings s;
    adj_->get_settings(s);
    float val = s.cur_lower;
    char buf[10];
    sprintf(buf, "%3.2f", val);
    CharString_var str = FrescoLib::string_ref(buf);
    fsubj_->replace_all(str);    // change subject
}


