/*
 * grays.cxx
 */

#include <Fresco/defs/fresco.h>
#include <Fresco/figures/figures.h>
#include <Fresco/layouts/layouts.h>
#include <Fresco/widgets/widgets.h>
#include "rgbview.h"

int main(int argc, char** argv) {
    FrescoContext* fc = FrescoLib::init_default_context(
	"FTutorial", argc, argv
    );
    FigureKit_var figures = Fresco_resolve_object(FigureKit, "figures_impl");
    WidgetKit_var widgets = Fresco_resolve_object(WidgetKit, "widgets_impl");
    LayoutKit_var layouts = Fresco_resolve_object(LayoutKit, "layouts_impl");
    
    FigureStyle_var figstyle = figures->new_style(
	FigureStyle_var(figures->default_style())
    );
    Coord size = Coord(100);
    Glyph_var rect = figures->rectangle(
	FigureKit::fill, figstyle, Coord(0),Coord(0), size,size
    );
    FrescoObject_var figview = new ColoredFigView(rect, figstyle);
    Adjustment_var a = widgets->bounded_float(0.0f, 100.0f, 50.0f);
    FrescoObject_var rgbview = new RgbView(a, a, a, figstyle);

    Viewer_var scrollbar = widgets->scroll_bar(Y_axis, a);
    Glyph_var hbox = layouts->hbox_align_elements(Alignment(0.5));
    hbox->append(Glyph_var(widgets->inset_frame(rect)));
    hbox->append(Glyph_var(layouts->hglue(Coord(8), Coord(0), Coord(0))));
    hbox->append(Glyph_var(layouts->vfixed(scrollbar, size+Coord(10))));

    Glyph_var g = layouts->back(
	 Glyph_var(widgets->outset_frame(
	     Glyph_var(layouts->margin(hbox, Coord(15)))
	 )),
	 Glyph_var(widgets->filler())
    );
    FrescoLib::run(scrollbar, g);
    CORBA::release(fc);
    return 0;
}
