/*
 * rgbview.h
 */

#ifndef rgbview_h
#define rgbview_h

#include <Fresco/defs/fresco.h>
#include <Fresco/figures/figures.h>
#include "ftutorial.h"

class RgbView : public FrescoObjectImpl {
public:
    RgbView(
	Adjustment_ptr r, Adjustment_ptr g, Adjustment_ptr b,
	FigureStyle_ptr c
    );
    ~RgbView();
    
protected:
    void update_red();
    void update_green();
    void update_blue();
    Color::Intensity value(Adjustment_ptr);

    FigureStyle_var figstyle_;
    DrawingKit_var drawkit_;
    Adjustment_var r_, g_, b_;
    FrescoObject_var rcallback_, gcallback_, bcallback_;
};


class ColoredFigView : public FrescoObjectImpl {
public:
    ColoredFigView(Glyph_ptr, FigureStyle_ptr);
    ~ColoredFigView();
    void update();
protected:
    Glyph_var fig_;
    FigureStyle_var figstyle_;
    Tag tag_;
};

#endif
