/*
 * value.cxx
 */

#include <Fresco/defs/fresco.h>
#include <Fresco/layouts/layouts.h>
#include <Fresco/widgets/widgets.h>
#include "floatview.h"

int main(int argc, char** argv) {
    FrescoContext* fc = FrescoLib::init_default_context(
	"FTutorial", argc, argv
    );
    WidgetKit_var widgets = Fresco_resolve_object(WidgetKit, "widgets_impl");
    LayoutKit_var layouts = Fresco_resolve_object(LayoutKit, "layouts_impl");
    
    FieldSubject_var fieldsubj = widgets->field_subject();
    Adjustment_var adj = widgets->bounded_float(0.0f, 50.0f, 0.0f);
    FrescoObject_var fv = new FloatView(fieldsubj, adj); 
    long nchars = 5;
    FieldEditor_var fe = widgets->field_editor(fieldsubj, nchars, nchars);
    Viewer_var scrollbar = widgets->scroll_bar(Y_axis, adj);
    
    Glyph_var vbox = layouts->vbox_align_elements(Alignment(0.5));
    vbox->append(Glyph_var(layouts->vfixed(scrollbar, Coord(140))));
    vbox->append(Glyph_var(layouts->vglue(Coord(5), Coord(0), Coord(0))));
    vbox->append(Glyph_var(widgets->inset_frame(fe)));
    
    Glyph_var g = layouts->back(
	Glyph_var(widgets->outset_frame(
	    Glyph_var(layouts->margin(vbox, Coord(20)))
        )),
	Glyph_var(widgets->filler())
    ); 
    FrescoLib::run(fe, g);
    CORBA::release(fc);
    return 0;
}
