//
// Copyright (c) 1987-91 Stanford University
// Copyright (c) 1991-94 Silicon Graphics, Inc.
// Copyright (c) 1993-94 Fujitsu, Ltd.
//
// Permission to use, copy, modify, distribute, and sell this software and 
// its documentation for any purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the names of
// Stanford, Silicon Graphics, and Fujitsu may not be used in any
// advertising or publicity relating to the software without the specific,
// prior written permission of Stanford, Silicon Graphics, and Fujitsu.
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
//
// IN NO EVENT SHALL STANFORD, SILICON GRAPHICS, OR FUJITSU BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
//

#ifndef Fresco_widgets_bfloat_h
#define Fresco_widgets_bfloat_h

#include <Fresco/widgets/widgets.h>
#include <Fresco/defs_impl/fobjects.h>

class BoundedFloat : public Adjustment {
public:
    BoundedFloat(float lower, float upper, float initial);
    ~BoundedFloat();

    OxExchange* _exchange();

    //+ Adjustment::*
    /* FrescoObject */
    Tag attach(XfFrescoObject_ptr observer);
    void detach(Tag attach_tag);
    void disconnect();
    void notify_observers();
    void update();
    /* Adjustment */
    Coord small_scroll();
    void small_scroll(Coord _p);
    Coord large_scroll();
    void large_scroll(Coord _p);
    void get_settings(Adjustment::Settings& s);
    void begin();
    void commit();
    void cancel();
    void scroll_forward();
    void scroll_backward();
    void page_forward();
    void page_backward();
    void scroll_to(Coord lower);
    void scroll_by(Coord delta);
    void scale_to(Coord length);
    void constrain(Coord& c);
    //+
protected:
    SharedFrescoObjectImpl object_;
    float value_;
    float lower_;
    float span_;
    Coord scroll_incr_;
    Coord page_incr_;
    Adjustment::Settings saved_;
};

#endif
