//
// Copyright (c) 1994-95 Firefly Design
// Copyright (c) 1991-94 Silicon Graphics, Inc.
// Copyright (c) 1993-94 Fujitsu, Ltd.
//
// Permission to use, copy, modify, distribute, and sell this software and
// its documentation for any purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the names
// of Stanford, Silicon Graphics, and Fujitsu may not be used in any
// advertising or publicity relating to the software without the specific,
// prior written permission of Stanford, Silicon Graphics, and Fujitsu.
//
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
//
// IN NO EVENT SHALL STANFORD, SILICON GRAPHICS, OR FUJITSU BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE
// OF THIS SOFTWARE.
//

#include <Fresco/defs_impl/math.h>
#include <Fresco/defs_impl/region.h>
#include <Fresco/defs_impl/transform.h>
#include <Fresco/layouts/layouts.h>
#include <X11/keysym.h>
#include "browser.h"

WKGridBrowser::WKGridBrowser(Grid_ptr g, XfColor_ptr c) : WKViewport(g) {
    grid_ = Grid::_duplicate(g);
    color_ = Color::_duplicate(c);
}

WKGridBrowser::~WKGridBrowser() {
}

OxExchange* WKGridBrowser::_exchange() {
    return WKViewport::_exchange();
}

//+ WKGridBrowser(XfFrescoObject::=WKViewport::)
XfTag WKGridBrowser::attach(XfFrescoObject_ptr observer) {
    return WKViewport::attach(observer);
}
void WKGridBrowser::detach(XfTag attach_tag) {
    WKViewport::detach(attach_tag);
}
void WKGridBrowser::disconnect() {
    WKViewport::disconnect();
}
void WKGridBrowser::notify_observers() {
    WKViewport::notify_observers();
}
void WKGridBrowser::update() {
    WKViewport::update();
}
//+

XfGlyph_ptr WKGridBrowser::clone_glyph() {
    return WKViewport::clone_glyph();
}
XfStyleContext_ptr WKGridBrowser::style() {
    return WKViewport::style();
}
void WKGridBrowser::style(XfStyleContext_ptr _p) {
    WKViewport::style(_p);
}
XfTransform_ptr WKGridBrowser::transformation() {
    return WKViewport::transformation();
}
void WKGridBrowser::request(XfGlyph::Requisition& r) {
    WKViewport::request(r);
}
void WKGridBrowser::extension(const XfGlyph::AllocationInfo& a, XfRegion_ptr r) {
    WKViewport::extension(a, r);
}
void WKGridBrowser::shape(XfRegion_ptr r) {
    WKViewport::shape(r);
}
void WKGridBrowser::draw(XfGlyphTraversal_ptr t) {
    WKViewport::draw(t);
}
void WKGridBrowser::pick(XfGlyphTraversal_ptr t) {
    WKViewport::pick(t);
}
XfGlyph_ptr WKGridBrowser::body() {
    return WKViewport::body();
}
void WKGridBrowser::body(XfGlyph_ptr _p) {
    WKViewport::body(_p);
}
void WKGridBrowser::append(XfGlyph_ptr g) {
    WKViewport::append(g);
}
void WKGridBrowser::prepend(XfGlyph_ptr g) {
    WKViewport::prepend(g);
}
XfTag WKGridBrowser::add_parent(XfGlyphOffset_ptr parent_offset) {
    return WKViewport::add_parent(parent_offset);
}
void WKGridBrowser::remove_parent(XfTag add_tag) {
    WKViewport::remove_parent(add_tag);
}
XfGlyphOffset_ptr WKGridBrowser::first_child_offset() {
    return WKViewport::first_child_offset();
}
XfGlyphOffset_ptr WKGridBrowser::last_child_offset() {
    return WKViewport::last_child_offset();
}
void WKGridBrowser::parent_offsets(XfGlyph::OffsetSeq& parents) {
    WKViewport::parent_offsets(parents);
}
void WKGridBrowser::allocations(XfGlyph::AllocationInfoSeq& a) {
    WKViewport::allocations(a);
}
void WKGridBrowser::need_redraw() {
    WKViewport::need_redraw();
}
void WKGridBrowser::need_redraw_region(XfRegion_ptr r) {
    WKViewport::need_redraw_region(r);
}
void WKGridBrowser::need_resize() {
    WKViewport::need_resize();
}
Boolean WKGridBrowser::restore_trail(XfGlyphTraversal_ptr t) {
    return WKViewport::restore_trail(t);
}

XfViewer_ptr WKGridBrowser::parent_viewer() {
    return WKViewport::parent_viewer();
}
XfViewer_ptr WKGridBrowser::next_viewer() {
    return WKViewport::next_viewer();
}
XfViewer_ptr WKGridBrowser::prev_viewer() {
    return WKViewport::prev_viewer();
}
XfViewer_ptr WKGridBrowser::first_viewer() {
    return WKViewport::first_viewer();
}
XfViewer_ptr WKGridBrowser::last_viewer() {
    return WKViewport::last_viewer();
}
void WKGridBrowser::append_viewer(XfViewer_ptr v) {
    WKViewport::append_viewer(v);
}
void WKGridBrowser::prepend_viewer(XfViewer_ptr v) {
    WKViewport::prepend_viewer(v);
}
void WKGridBrowser::insert_viewer(XfViewer_ptr v) {
    WKViewport::insert_viewer(v);
}
void WKGridBrowser::replace_viewer(XfViewer_ptr v) {
    WKViewport::replace_viewer(v);
}
void WKGridBrowser::remove_viewer() {
    WKViewport::remove_viewer();
}
void WKGridBrowser::set_viewer_links(XfViewer_ptr parent, XfViewer_ptr prev, XfViewer_ptr next) {
    WKViewport::set_viewer_links(parent, prev, next);
}
void WKGridBrowser::set_first_viewer(XfViewer_ptr v) {
    WKViewport::set_first_viewer(v);
}
void WKGridBrowser::set_last_viewer(XfViewer_ptr v) {
    WKViewport::set_last_viewer(v);
}
XfFocus_ptr WKGridBrowser::request_focus(XfViewer_ptr requestor, Boolean temporary) {
    return WKViewport::request_focus(requestor, temporary);
}
Boolean WKGridBrowser::receive_focus(XfFocus_ptr f, Boolean primary) {
    return WKViewport::receive_focus(f, primary);
}
void WKGridBrowser::lose_focus(Boolean temporary) {
    WKViewport::lose_focus(temporary);
}
Boolean WKGridBrowser::first_focus() {
    return WKViewport::first_focus();
}
Boolean WKGridBrowser::last_focus() {
    return WKViewport::last_focus();
}
Boolean WKGridBrowser::next_focus() {
    return WKViewport::next_focus();
}
Boolean WKGridBrowser::prev_focus() {
    return WKViewport::prev_focus();
}
void WKGridBrowser::close() {
    WKViewport::close();
}

//+ WKGridBrowser(Viewport::=WKViewport::)
Adjustment_ptr WKGridBrowser::scroll_adjustment(XfAxis a) {
    return WKViewport::scroll_adjustment(a);
}
//+

void WKGridBrowser::traverse(XfGlyphTraversal_ptr t) {
    Painter_var p = t->current_painter();
    Region_var a = t->allocation();

    Boolean hit = t->is_pick_op() && t->allocation_is_visible();

    check_allocation(a);
    Flags flags = push_environment(p, a);

    if (hit) {
        t->begin_viewer(Viewer_ptr(this));
        t->hit();
        t->end_viewer();
    } else {
        Region_var b = body_allocation(a);
        if (t->op() == GlyphTraversal::draw) {
            p->current_color(color_);
            RegionImpl r;
            Long count = selection_.length();
            for (Long i = 0; i < count; ++i) {
                allocation(a, b, selection_[i], &r);
                Vertex lower, upper;
                r.bounds(lower, upper);
                p->fill_rect(lower.x, lower.y, upper.x, upper.y);
            }
        }

        if (is_not_nil(offset_.child_)) {
            t->traverse_child(&offset_, b);
        }
    }

    pop_environment(p, flags);
}

Boolean WKGridBrowser::handle(XfGlyphTraversal_ptr t, XfEvent_ptr e) {
    Boolean result = false;
    if (e->type() == Event::key_press) {
        switch (e->key()) {
            case XK_Up: {
                select_move(t, e, 0, +1);
                result = true;
            } break;
            case XK_Down: {
                select_move(t, e, 0, -1);
                result = true;
            } break;
            case XK_Left: {
                select_move(t, e, -1, 0);
                result = true;
            } break;
            case XK_Right: {
                select_move(t, e, +1, 0);
                result = true;
            } break;
        }
    } else if (e->type() == Event::down) {
        select_point(t, e);
        result = true;
    }
    return result;
}

void WKGridBrowser::select(const Grid::IndexSeq& s) {
    selection_ = s;
}

Grid::IndexSeq* WKGridBrowser::selection() {
    return new Grid::IndexSeq(selection_);
}

XfAction_ptr WKGridBrowser::select_action() {
    return Action::_duplicate(select_action_);
}

void WKGridBrowser::select_action(XfAction_ptr _p) {
    select_action_ = Action::_duplicate(_p);
}

void WKGridBrowser::damage(Region_ptr a, Region_ptr b, const Grid::Index& index) {
    RegionImpl d;
    allocation(a, b, index, &d);
    d.apply_transform(tx_);
    need_redraw_region(&d);
}

void WKGridBrowser::allocation(
    Region_ptr a, Region_ptr b, const Grid::Index& index, Region_ptr r
) {
    RegionImpl c;
    grid_->allocate_cell(b, index, &c);

    XfRegion::BoundingSpan x, y;
    a->span(X_axis, x);
    a->span(Y_axis, y);

    Grid::Index upper = grid_->upper();
    if (upper.col == 1) {
        c.lower_.x = x.begin;
        c.upper_.x = x.end;
    }
    if (upper.row == 1) {
        c.lower_.y = y.begin;
        c.upper_.y = y.end;
    }

    r->copy(&c);
}

void WKGridBrowser::select_move(
    XfGlyphTraversal_ptr t, XfEvent_ptr, Long cols, Long rows
) {
    Region_var a = t->allocation();
    Region_var b = body_allocation(a);
    Long count = selection_.length();
    if (count == 0) {
        if (selection_.maximum() <= 0) {
            selection_.alloc(1);
        }
        selection_.length(1);
        selection_[0].row = 0;
        selection_[0].col = 0;
        damage(a, b, selection_[0]);
    } else {
        Grid::Index min, max;
        min.row = max.row = selection_[0].row;
        min.col = max.col = selection_[0].col;
        for (Long i = 1; i < count; ++i) {
            Grid::Index& index = selection_[i];
            if (index.row < min.row) min.row = index.row;
            if (index.col < min.col) min.col = index.col;
            if (index.row > max.row) min.row = index.row;
            if (index.col > max.col) min.col = index.col;
        }
        Grid::Index upper = grid_->upper();
        if (rows > 0) {
            rows = Math::min(rows, upper.row - 1 - max.row);
        } else {
            rows = Math::max(rows, -min.row);
        }
        if (cols > 0) {
            cols = Math::min(cols, upper.col - 1 - max.col);
        } else {
            cols = Math::max(cols, -min.col);
        }
        for (i = 0; i < count; ++i) {
            Grid::Index& index = selection_[i];
            damage(a, b, index);
            index.row += rows;
            index.col += cols;
            damage(a, b, index);
        }
    }
}

void WKGridBrowser::select_point(XfGlyphTraversal_ptr t, XfEvent_ptr) {
    Grid::Index index = grid_->find(t);
    Region_var a = t->allocation();
    Region_var b = body_allocation(a);
    Long count = selection_.length();
    for (Long i = 0; i < count; ++i) {
        damage(a, b, selection_[i]);
    }
    if (selection_.maximum() <= 0) {
        selection_.alloc(1);
    }
    selection_.length(1);
    selection_[0] = index;
    damage(a, b, selection_[0]);
    if (is_not_nil(select_action_)) {
        select_action_->execute();
    }
}
